# shinyWidgets

> Extend widgets available in [shiny](https://github.com/rstudio/shiny)

<!-- badges: start -->
[![CRAN status](https://www.r-pkg.org/badges/version/shinyWidgets)](https://CRAN.R-project.org/package=shinyWidgets)
[![cranlogs](https://cranlogs.r-pkg.org/badges/shinyWidgets?color=brightgreen)](https://CRAN.R-project.org/package=shinyWidgets)
[![cran checks](https://badges.cranchecks.info/worst/shinyWidgets.svg)](https://cran.r-project.org/web/checks/check_results_shinyWidgets.html)
[![Coverage Status](https://img.shields.io/codecov/c/github/dreamRs/shinyWidgets/master.svg)](https://app.codecov.io/github/dreamRs/shinyWidgets?branch=master)
[![AppVeyor build status](https://ci.appveyor.com/api/projects/status/github/dreamRs/shinyWidgets?branch=master&svg=true)](https://ci.appveyor.com/project/dreamRs/shinyWidgets)
[![R-CMD-check](https://github.com/dreamRs/shinyWidgets/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/dreamRs/shinyWidgets/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->


## Overview

This package provide custom widgets and other components to enhance your shiny applications.

You can replace classical checkboxes with switch button, add colors to radio buttons and checkbox group, use buttons as radio or checkboxes.
Each widget has an `update` method to change the value of an input from the server.



## Installation

Install from [CRAN](https://CRAN.R-project.org/package=shinyWidgets) with:

```r
install.packages("shinyWidgets")
```

Or install the development version from [GitHub](https://github.com/dreamRs/shinyWidgets) with:

```r
# install.packages("remotes")
remotes::install_github("dreamRs/shinyWidgets")
```


## Demo

A gallery application is included in the package. Once installed, use the following command to launch it:

```r
shinyWidgets::shinyWidgetsGallery()
```

A live version is available here : http://shinyapps.dreamrs.fr/shinyWidgets


## Widgets

### Single checkbox

* **Bootstrap switch**

Turn checkboxes into toggle switches : 

![switchInput](man/figures/switchInput.png)

```r
switchInput(inputId = "id", value = TRUE)
```


* **Material switch**

Turn checkboxes into toggle switches :

![materialSwitch](man/figures/materialSwitch.png)

```r
materialSwitch(inputId = "id", label = "Primary switch", status = "danger")
```


* **Pretty checkbox**

```r
prettyCheckbox(
  inputId = "id", label = "Check me!", icon = icon("check")
)
```


* **Pretty switch**

```r
prettySwitch(
  inputId = "id",
  label = "Switch:",
  fill = TRUE, 
  status = "primary"
)
```


* **Pretty toggle**

```r
prettyToggle(
  inputId = "id",
  label_on = "Checked!",
  label_off = "Unchecked..."
)
```

### Checkboxes and radio buttons

* **Bootstrap buttons**

![checkboxGroupButtons](man/figures/checkboxGroupButtons.png)

```r
checkboxGroupButtons( # or radioGroupButtons
  inputId = "id",
  label = "Choice: ",
  choices = c("A", "B", "C")
)
```

* **Pretty checkbox group and radio buttons**

```r
prettyCheckboxGroup( # or prettyRadioButtons
  inputId = "id",
  label = "Choice",
  choices = c("A", "B", "c"),
  outline = TRUE,
  plain = TRUE,
  status = "primary",
  icon = icon("check")
)
```


### Select menu

* **Bootstrap select picker**

Select menu with lot of configurations options available:

![pickerInput](man/figures/pickerInput.png)

```r
pickerInput(
  inputId = "id", 
  label = "Select:", 
  choices = month.name, 
  options = pickerOptions(
    actionsBox = TRUE, 
    size = 10,
    selectedTextFormat = "count > 3"
  ), 
  multiple = TRUE
)
```

* **Virtual select**

Select menu that can support long list of choices:

![virtualSelectInput](man/figures/virtual-select.png)

```r
virtualSelectInput(
  inputId = "id",
  label = "Select:",
  choices = list(
    "Spring" = c("March", "April", "May"),
    "Summer" = c("June", "July", "August"),
    "Autumn" = c("September", "October", "November"),
    "Winter" = c("December", "January", "February")
  ),
  showValueAsTags = TRUE,
  search = TRUE,
  multiple = TRUE
)
```


### Date picker

* **Air Datepicker**

Date (or month or year) picker with lot of options and a timepicker integrated :

![airDatepickerInput](man/figures/air-datepicker.png)

```r
airDatepickerInput(
  inputId = "id",
  label = "Select:",
  placeholder = "Placeholder",
  multiple = 5, 
  clearButton = TRUE
)
```

### Sliders

* **Slider with Text**

Slider with strings, to pass whatever you want:

![sliderText](man/figures/sliderText.png)

```r
sliderTextInput(
  inputId = "id", 
  label = "Choice:", 
  grid = TRUE, 
  force_edges = TRUE,
  choices = c(
    "Strongly disagree",
    "Disagree",
    "Neither agree nor disagree", 
    "Agree", 
    "Strongly agree"
  )
)
```


* **noUiSlider**

A range slider that can be colored, have more than two handles and positioned vertically (among other things):

![noUiSliderInput](man/figures/nouislider.png)

```r
noUiSliderInput(
  inputId = "id",
  label = "Select:",
  min = 0, 
  max = 600,
  value = c(100, 220, 400),
  tooltips = TRUE,
  step = 1
)
```



### Tree

* **Tree check**

Select value(s) in a hierarchical structure:

![treeInput](man/figures/treeinput.png)

```r
treeInput(
  inputId = "ID2",
  label = "Select cities:",
  choices = create_tree(cities),
  returnValue = "text",
  closeDepth = 1
)
```



### Text

* **Search**

A text input only triggered by hitting 'Enter' or clicking search button : 

![search_input](man/figures/search_input.png)

```r
searchInput(
  inputId = "id", 
  label = "Enter your search :", 
  placeholder = "This is a placeholder", 
  btnSearch = icon("search"), 
  btnReset = icon("remove"), 
  width = "100%"
)
```



## Other functionnalities

### Sweet Alert

Show an alert message to the user to provide some feedback, via [sweetalert2](https://sweetalert2.github.io/) library:

![sendSweetAlert](man/figures/show_alert.png)

See examples in `?show_alert`.


Request confirmation from the user :

![confirmSweetAlert](man/figures/ask_confirmation.png)

See examples in `?ask_confirmation`.



### Dropdown button

Hide input in a button : <br>
![dropdown_off](man/figures/dropdown_btn_off.png)
![dropdown_on](man/figures/dropdown_btn_on.png)

```r
dropdownButton(
  tags$h3("List of Input"),
  selectInput(inputId = 'xcol', label = 'X Variable', choices = names(iris)),
  selectInput(inputId = 'ycol', label = 'Y Variable', choices = names(iris), selected = names(iris)[[2]]),
  sliderInput(inputId = 'clusters', label = 'Cluster count', value = 3, min = 1, max = 9),
  circle = TRUE,
  status = "danger", 
  icon = icon("gear"), width = "300px",
  tooltip = tooltipOptions(title = "Click to see inputs !")
)
```

See also `?dropMenu()`



## Development

This package use [{packer}](https://github.com/JohnCoene/packer) to manage JavaScript assets, see packer's [documentation](https://packer.john-coene.com/#/) for more.

Install nodes modules with:

```r
packer::npm_install()
```

Modify inputs bindings in `srcjs/inputs/`, then run:

```r
packer::bundle()
```

Re-install R package and try functions.

library(shiny)
library(shinyWidgets)

state_data <- data.frame(
  name = state.name,
  abb = state.abb,
  region = state.region,
  division = state.division
)

ui <- fluidPage(
  tags$h2("Virtual Select: prepare choices"),

  virtualSelectInput(
    inputId = "sel1",
    label = "Use a data.frame:",
    choices = prepare_choices(state_data, name, abb),
    search = TRUE
  ),
  verbatimTextOutput("res1"),

  virtualSelectInput(
    inputId = "sel2",
    label = "Group choices:",
    choices = prepare_choices(state_data, name, abb, region),
    multiple = TRUE
  ),
  verbatimTextOutput("res2"),

  virtualSelectInput(
    inputId = "sel3",
    label = "Add a description:",
    choices = prepare_choices(state_data, name, abb, description = division),
    multiple = TRUE,
    hasOptionDescription = TRUE
  ),
  verbatimTextOutput("res3")
)

server <- function(input, output, session) {
  output$res1 <- renderPrint(input$sel1)
  output$res2 <- renderPrint(input$sel2)
  output$res3 <- renderPrint(input$sel3)
}

if (interactive())
  shinyApp(ui, server)

.shinyWidgetGalleryFuns$tabradioButtons <- function() {
  tagList(
    tags$h1("Turn buttons into radio", class = "fw-bold text-primary"),
    br(),

    fluidRow(

      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Default",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioGroupButtons,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Label", choices = c("A", "B", "C"))
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "With choices",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioGroupButtons,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Label", choices = c("A", "B", "C", "D"), selected = "B")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Danger status",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioGroupButtons,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Label", choices = c("A", "B", "C", "D"), status = "danger")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Success status",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioGroupButtons,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Label", choices = c("A", "B", "C", "D"), status = "success")
          )
        )
      ),

      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Justified",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioGroupButtons,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Label", choices = c("A", "B"), justified = TRUE)
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Vertical",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioGroupButtons,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Label", choices = c("A", "B", "C", "D"), direction = "vertical")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Large",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioGroupButtons,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Label", choices = c("A", "B", "C", "D"), size = "lg")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Update",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioGroupButtons,
            args = list(inputId = "upradioGroupButtons", label = "Label", choices = c("A", "B", "C", "D"),
                        checkIcon = list(yes = icon("ok", lib = "glyphicon")))
          ),
          br(),
          tags$p("Click to update :"),
          actionGroupButtons(inputIds = c("upRadioBtnA", "upRadioBtnB", "upRadioBtnC", "upRadioBtnD"), labels = c("A", "B", "C", "D"))
        )
      ),

      column(
        width = 4,

        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Large",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioGroupButtons,
            args = list(
              inputId = ID(.shinyWidgetGalleryId), label = "Choose a graph :",
              choices = c(
                "<i class='fa fa-bar-chart'></i>" = "bar",
                "<i class='fa fa-line-chart'></i>" = "line",
                "<i class='fa fa-pie-chart'></i>" = "pie"
              ), justified = TRUE
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Icons",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioGroupButtons,
            args = list(
              inputId = ID(.shinyWidgetGalleryId), label = "Label", choices = c("A", "B", "C", "D"), justified = TRUE,
              checkIcon = list(yes = icon("ok", lib = "glyphicon"))
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "More icons",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioGroupButtons,
            args = list(
              inputId = ID(.shinyWidgetGalleryId), label = "Label", choices = c("A", "B", "C", "D"), status = "primary",
              checkIcon = list(yes = icon("ok", lib = "glyphicon"), no = icon("xmark", lib = "glyphicon"))
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Colored icons",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioGroupButtons,
            args = list(
              inputId = ID(.shinyWidgetGalleryId), label = "Label", choices = c("Option 1", "Option 2", "Option 3", "Option 4"),
              checkIcon = list(yes = tags$i(class = "fa fa-check-square", style = "color: steelblue"),
                               no = tags$i(class = "fa fa-square-o", style = "color: steelblue")))
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Separated buttons",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioGroupButtons,
            args = list(
              inputId = ID(.shinyWidgetGalleryId), label = "Label", choices = c("Option 1", "Option 2", "Option 3", "Option 4"), individual = TRUE,
              checkIcon = list(yes = tags$i(class = "fa fa-circle", style = "color: steelblue"),
                               no = tags$i(class = "fa fa-circle-o", style = "color: steelblue"))
            )
          )
        )

      )
    )
  )
}

#  ------------------------------------------------------------------------
#
# Title : Compile awesome-bootstrap CSS
#    By : Victor
#  Date : 2020-05-08
#
#  ------------------------------------------------------------------------



# Package -----------------------------------------------------------------

library(sass)




# CSS ---------------------------------------------------------------------


# From original file, prefix "awesome-" have been added to checkbox & radio classes to
# prevent conficts with Shiny base function
# padding was changed from from 20px to 5px


sass(
  input = list(

    sass_file(input = system.file(
      "assets/bootstrap-3.4.1/default/stylesheets/bootstrap/_variables.scss",
      package = "fresh"
    )),

    sass_file(input = system.file(
      "assets/bootstrap-3.4.1/default/stylesheets/bootstrap/_mixins.scss",
      package = "fresh"
    )),

    sass_file(input = "inst/assets/awesome-bootstrap-checkbox/awesome-bootstrap-checkbox.scss")

  ),
  options = sass_options(output_style = "compressed"),
  output = "inst/assets/awesome-bootstrap-checkbox/awesome-bootstrap-checkbox.min.css"
)

# after check icon content, there's a bug with unicode character (replace with \f00c)

.shinyWidgetGalleryFuns$tabOverview <- function() {

  countries <- list(
    "France", "United Kingdom", "Germany", "United States of America", "Belgium", "China", "Spain", "Netherlands", "Mexico",
    "Italy", "Canada", "Brazil", "Denmark", "Norway", "Switzerland", "Luxembourg", "Israel", "Russian Federation",
    "Turkey", "Saudi Arabia", "United Arab Emirates"
  )
  flags <- c("fr", "gb", "de", "us", "be", "cn", "es", "nl", "mx", "it", "ca", "br", "dk", "no", "ch", "lu", "il", "ru", "tr", "sa", "ae")
  flags <- sprintf("https://cdn.rawgit.com/lipis/flag-icon-css/master/flags/4x3/%s.svg", flags)

  tagList(
    tags$h1("shinyWidgets Overview", class = "fw-bold text-primary"),
    br(),

    fluidRow(

      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Awesome checkbox Group",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = awesomeCheckboxGroup,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Checkboxes with status", choices = c("A", "B", "C"), inline = TRUE)
          ),
          footer = actionLink(inputId = "toAwesome1", label = "More examples", icon = icon("plus"))
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Checkbox Group Buttons",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = checkboxGroupButtons,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Choices", choices = c("Choice 1", "Choice 2", "Choice 3"))
          ),
          footer = actionLink(inputId = "tocheckButtons", label = "More examples", icon = icon("plus"))
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Awesome Radio Buttons",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = awesomeRadio,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Radio with status", choices = c("A", "B", "C"), selected = "B", status = "warning")
          ),
          footer = actionLink(inputId = "toAwesome2", label = "More examples", icon = icon("plus"))
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Radio Group Buttons",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioGroupButtons,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Choices", choices = c("Choice 1", "Choice 2", "Choice 3"))
          )
        )
      )
      ,
      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Awesome checkbox",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = awesomeCheckbox,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "A single checkbox", value = TRUE)
          ),
          footer = actionLink(inputId = "toAwesome3", label = "More examples", icon = icon("plus"))
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Material Design Switch",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = materialSwitch,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Primary switch", status = "primary", right = TRUE)
          ),
          footer = actionLink(inputId = "toMaterialSwitch", label = "More examples", icon = icon("plus"))
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Bootstrap Switch",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = switchInput,
            args = list(inputId = ID(.shinyWidgetGalleryId), value = TRUE)
          ),
          footer = actionLink(inputId = "toSwictchInput", label = "More examples", icon = icon("plus"))
        )
      )
      ,
      column(
        width = 4,

        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Select Picker",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId), label = "With plain HTML",
              choices = paste("Badge", c("info", "success", "danger", "primary", "warning")),
              multiple = TRUE, selected = "Badge danger",
              choicesOpt = list(
                content=sprintf(
                  # "<span class='badge badge-%1$s bg-%1$s'>%2$s</span>", c("info", "success", "danger", "primary", "warning"),
                  "<span class='badge text-bg-%s'>%s</span>", c("info", "success", "danger", "primary", "warning"),
                  paste("Badge", c("info", "success", "danger", "primary", "warning"))
                )
              ),
              options = pickerOptions(container = "body")
            )
          ),
          footer = actionLink(inputId = "toSelectPicker", label = "More examples", icon = icon("plus"))
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Search field",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = searchInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId), label = "Click search icon to update or hit 'Enter'",
              placeholder = "A placeholder",
              btnSearch = icon("magnifying-glass"),
              btnReset = icon("xmark"),
              width = "100%"
            )
          )
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Multi.js",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = multiInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Countries :", choices = NULL,
              choiceNames = lapply(seq_along(countries), function(i) tagList(tags$img(src = flags[i], width=20, height=15), countries[i])),
              choiceValues = countries,
              width = "100%"
            )
          )
        )
      )
    )
  )
}

library(shiny)
library(shinyWidgets)
library(htmltools)
library(phosphoricons)


ui <- fluidPage(
  html_dependency_winbox(),
  actionButton(inputId = "show", label = "Show one or more WinBox"),
  radioButtons(
    inputId = "background",
    label = "Background color:",
    choices = c("forestgreen", "firebrick", "steelblue", "goldenrod")
  ),
  checkboxInput(
    inputId = "modal",
    label = "Shows the window as modal",
    value = FALSE
  ),
  checkboxInput(
    inputId = "autosize",
    label = "Automatically size the window to fit the window contents.",
    value = FALSE
  ),
  checkboxInput(
    inputId = "max",
    label = "Automatically toggles the window into maximized state when created.",
    value = FALSE
  ),
  checkboxInput(
    inputId = "min",
    label = "Automatically toggles the window into minimized state when created.",
    value = FALSE
  )
)

server <- function(input, output, session) {

  observeEvent(input$show, {
    WinBox(
      title = "This is a WinBox",
      ui = tagList(
        tags$h3("Hello from WinBox!")
      ),
      options = wbOptions(
        background = input$background,
        modal = input$modal,
        autosize = input$autosize,
        max = input$max,
        min = input$min
      )
    )
  })

}

if (interactive())
  shinyApp(ui, server)

library(shiny)
library(shinyWidgets)

parseValue <- TRUE

ui <- fluidPage(
  theme = bslib::bs_theme(5),
  tags$h2("Calendar Pro Input"),
  fluidRow(
    column(
      width = 6,
      calendarProInput(
        inputId = "cal1",
        label = "Date selection:",
        placeholder = "Select a date",
        width = "100%",
        parseValue = parseValue
      ),
      verbatimTextOutput("res1"),

      calendarProInput(
        inputId = "cal3",
        label = "Date selection (with default):",
        value = Sys.Date() + 2,
        placeholder = "Select a date",
        width = "100%",
        parseValue = parseValue
      ),
      verbatimTextOutput("res3"),

      calendarProInput(
        inputId = "cal5",
        label = "Multiple date selection:",
        mode = "multiple",
        placeholder = "Select multiple date ",
        width = "100%",
        parseValue = parseValue
      ),
      verbatimTextOutput("res5"),

      calendarProInput(
        inputId = "cal7",
        label = "Range date selection:",
        mode = "multiple-ranged",
        placeholder = "Select range of dates ",
        width = "100%",
        parseValue = parseValue
      ),
      verbatimTextOutput("res7"),

      calendarProInput(
        inputId = "cal9",
        label = "Month selection:",
        placeholder = "Select a month",
        type = "month",
        # selectedYear = 2022, # to change default year
        width = "100%",
        parseValue = parseValue,
        format = "%Y-%m"
      ),
      verbatimTextOutput("res9"),

      calendarProInput(
        inputId = "cal11",
        label = "Year selection:",
        placeholder = "Select a year",
        type = "year",
        selectionMonthsMode = FALSE,
        selectedMonth = 0,
        width = "100%",
        parseValue = parseValue,
        format = "%Y"
      ),
      verbatimTextOutput("res11")
    ),
    column(
      width = 6,

      calendarProInput(
        inputId = "cal2",
        label = "Datetime selection:",
        placeholder = "Select date and time",
        selectionTimeMode = 12,
        width = "100%",
        parseValue = parseValue,
        format = "%Y-%m-%d %H:%M"
      ),
      verbatimTextOutput("res2"),

      calendarProInput(
        inputId = "cal4",
        label = "Datetime selection (with default as POSIXct):",
        value = as.POSIXct(paste(Sys.Date(), "9:00")),
        selectionTimeMode = 24,
        placeholder = "Select date and time",
        width = "100%",
        parseValue = parseValue,
        format = "%Y-%m-%d %H:%M"
      ),
      verbatimTextOutput("res4"),

      calendarProInput(
        inputId = "cal6",
        label = "Datetime selection (with selectedTime default):",
        value = Sys.Date(),
        selectionTimeMode = 24,
        selectedTime = "10:00",
        placeholder = "Select date and time",
        width = "100%",
        parseValue = parseValue,
        format = "%Y-%m-%d %H:%M"
      ),
      verbatimTextOutput("res6"),

      calendarProInput(
        inputId = "cal8",
        label = "Datetime multiple selection (with default):",
        value = as.POSIXct(paste(Sys.Date(), "9:00")),
        selectionTimeMode = 24,
        mode = "multiple",
        placeholder = "Select date and time",
        width = "100%",
        parseValue = parseValue,
        format = "%Y-%m-%d %H:%M"
      ),
      verbatimTextOutput("res8"),

      calendarProInput(
        inputId = "cal10",
        label = "Datetime range selection (with default):",
        value = as.POSIXct(paste(Sys.Date(), "9:00")),
        selectionTimeMode = 24,
        mode = "multiple-ranged",
        placeholder = "Select date and time",
        width = "100%",
        parseValue = parseValue,
        format = "%Y-%m-%d %H:%M"
      ),
      verbatimTextOutput("res10")
    )
  )
)

server <- function(input, output, session) {

  output$res1 <- renderPrint(str(input$cal1))
  output$res2 <- renderPrint(str(input$cal2))
  output$res3 <- renderPrint(str(input$cal3))
  output$res4 <- renderPrint(str(input$cal4))
  output$res5 <- renderPrint(str(input$cal5))
  output$res6 <- renderPrint(str(input$cal6))
  output$res7 <- renderPrint(str(input$cal7))
  output$res8 <- renderPrint(str(input$cal8))
  output$res9 <- renderPrint(str(input$cal9))
  output$res10 <- renderPrint(str(input$cal10))
  output$res11 <- renderPrint(str(input$cal11))

}

if (interactive())
  shinyApp(ui, server)

library("shiny")
library("shinyWidgets")

ui <- fluidPage(
  tags$h2("Dropdown Button"),
  br(),
  dropdownButton(

    tags$h3("List of Inputs"),

    selectInput(inputId = 'xcol',
                label = 'X Variable',
                choices = names(iris)),

    selectInput(inputId = 'ycol',
                label = 'Y Variable',
                choices = names(iris),
                selected = names(iris)[[2]]),

    sliderInput(inputId = 'clusters',
                label = 'Cluster count',
                value = 3,
                min = 1,
                max = 9),

    circle = TRUE, status = "danger",
    icon = icon("gear"), width = "300px",

    tooltip = tooltipOptions(title = "Click to see inputs !")
  ),

  plotOutput(outputId = 'plot1')
)

server <- function(input, output, session) {

  selectedData <- reactive({
    iris[, c(input$xcol, input$ycol)]
  })

  clusters <- reactive({
    kmeans(selectedData(), input$clusters)
  })

  output$plot1 <- renderPlot({
    palette(c("#E41A1C", "#377EB8", "#4DAF4A", "#984EA3",
              "#FF7F00", "#FFFF33", "#A65628", "#F781BF", "#999999"))

    par(mar = c(5.1, 4.1, 0, 1))
    plot(selectedData(),
         col = clusters()$cluster,
         pch = 20, cex = 3)
    points(clusters()$centers, pch = 4, cex = 4, lwd = 4)
  })

}

shinyApp(ui = ui, server = server)

library(shiny)
library(shinyWidgets)

ui <- fluidPage(
  tags$h2("Virtual Select (choices format)"),

  virtualSelectInput(
    inputId = "sel1",
    label = "Simple vector:",
    choices = month.name
  ),
  verbatimTextOutput("res1"),

  virtualSelectInput(
    inputId = "sel2",
    label = "Named vector:",
    choices = setNames(month.abb, month.name)
  ),
  verbatimTextOutput("res2"),

  virtualSelectInput(
    inputId = "sel3",
    label = "Named list:",
    choices = setNames(as.list(month.abb), month.name)
  ),
  verbatimTextOutput("res3"),

  virtualSelectInput(
    inputId = "sel4",
    label = "With groups:",
    choices = list(
      Winter = month.name[1:3],
      Spring = month.name[4:6],
      Summer = month.name[7:9],
      Fall = month.name[10:12]
    )
  ),
  verbatimTextOutput("res4"),

  virtualSelectInput(
    inputId = "sel5",
    label = "Already formated list:",
    choices = list(
      list(label = "January", value = "jan"),
      list(label = "February", value = "feb")
    )
  ),
  verbatimTextOutput("res5"),

  virtualSelectInput(
    inputId = "sel6",
    label = "With HTML in choices:",
    choices = setNames(
      as.list(month.abb),
      sprintf(
        "<b style='color: red;'>%s</span>",
        month.name
      )
    ),
    html = TRUE
  ),
  verbatimTextOutput("res6")
)

server <- function(input, output, session) {
  output$res1 <- renderPrint(input$sel1)
  output$res2 <- renderPrint(input$sel2)
  output$res3 <- renderPrint(input$sel3)
  output$res4 <- renderPrint(input$sel4)
  output$res5 <- renderPrint(input$sel5)
  output$res6 <- renderPrint(input$sel6)
}

if (interactive())
  shinyApp(ui, server)

library(shiny)
library(shinyWidgets)

ui <- fluidPage(
  tags$h3("Behaviour noUiSlider"),
  tags$br(),

  fluidRow(

    column(
      width = 6,

      panel(
        heading = "tap", status = "info",
        noUiSliderInput(
          inputId = "beh1", label = "Click the slider to move the handle",
          min = 0, max = 500, value = 200,
          color = "#D9EDF7", behaviour = "tap"
        ),
        verbatimTextOutput(outputId = "res1")
      ),

      panel(
        heading = "drag-tap", status = "info",
        noUiSliderInput(
          inputId = "beh3", label = "Drag range and move closest handle to click position",
          min = 0, max = 500, value = c(200, 300),
          color = "#D9EDF7", behaviour = c("tap", "drag")
        ),
        verbatimTextOutput(outputId = "res3")
      ),

      panel(
        heading = "snap", status = "info",
        noUiSliderInput(
          inputId = "beh5", label = "Move handle to clicked position and can be moved without a 'mouseup'",
          min = 0, max = 500, value = 200,
          color = "#D9EDF7", behaviour = "snap"
        ),
        verbatimTextOutput(outputId = "res5")
      )

    ),

    column(
      width = 6,

      panel(
        heading = "drag", status = "info",
        noUiSliderInput(
          inputId = "beh2", label = "Range is draggable",
          min = 0, max = 500, value = c(200, 300),
          color = "#D9EDF7", behaviour = "drag"
        ),
        verbatimTextOutput(outputId = "res2")
      ),

      panel(
        heading = "drag-fixed", status = "info",
        noUiSliderInput(
          inputId = "beh4", label = "Range is draggable, handles are linked",
          min = 0, max = 500, value = c(200, 300),
          color = "#D9EDF7", behaviour = c("drag", "fixed")
        ),
        verbatimTextOutput(outputId = "res4")
      )

    )

  )
)

server <- function(input, output, session) {

  lapply(
    X = seq_len(10),
    FUN = function(i) {
      output[[paste0("res", i)]] <- renderPrint(input[[paste0("beh", i)]])
    }
  )

}

shinyApp(ui, server)

# ------------------------------------------------------------------------ #
#
# Descriptif : Select picker
#     Detail : https://silviomoreto.github.io/bootstrap-select/examples/
#
#
# Auteur : Victor PERRIER
#
# Date creation : 08/09/2016
# Date modification : 08/09/2016
#
# Version 1.0
#
# ------------------------------------------------------------------------ #




# Bootstrap switch --------------------------------------------------------


library("shiny")
library("shinyWidgets")

basicPanel <- function(..., width = 4) {
  column(
    width = width,
    tags$div(
      class="panel panel-default", style="border: 1px solid; border-color: steelblue;",
      tags$div(
        class="panel-body",
        ...
      )
    )
  )
}




fluidPage(
  tags$h1("Select Picker Gallery", style="color: steelblue;"),
  tags$h5(
    "via ",
    tags$a(href = "https://silviomoreto.github.io/bootstrap-select/examples/", "select-picker"),
    style="color: steelblue;"
  ),


  fluidRow(

    basicPanel(
      pickerInput(inputId = "id1", label = "Default", choices = c("a", "b", "c", "d")),
      verbatimTextOutput("res1")
    ),

    basicPanel(
      pickerInput(
        inputId = "id2", label = "Options group",
        choices = list(lower = c("a", "b", "c", "d"), upper = c("A", "B", "C", "D"))
      ),
      verbatimTextOutput("res2")
    ),

    basicPanel(
      pickerInput(
        inputId = "id3", label = "Multiple", choices = attr(UScitiesD, "Labels"), multiple = TRUE
      ),
      verbatimTextOutput("res3")
    ),

    basicPanel(
      pickerInput(
        inputId = "id4", label = "Live search", choices = attr(UScitiesD, "Labels"),
        options = list("live-search" = TRUE)
      ),
      verbatimTextOutput("res4")
    ),

    basicPanel(
      pickerInput(
        inputId = "id5", label = "Placeholder", choices = c("a", "b", "c", "d"),
        options = list(title = "This is a placeholder")
      ),
      verbatimTextOutput("res5")
    ),

    basicPanel(
      pickerInput(
        inputId = "id6", label = "Selected text format (select >3 items)", choices = LETTERS,
        options = list(`selected-text-format` = "count > 3"), multiple = TRUE
      ),
      verbatimTextOutput("res6")
    ),

    basicPanel(
      pickerInput(
        inputId = "id7", label = "Style : primary", choices = c("a", "b", "c", "d"),
        options = list(`style` = "btn-primary")
      ),
      verbatimTextOutput("res7")
    ),

    basicPanel(
      pickerInput(
        inputId = "id8", label = "Style : danger", choices = c("a", "b", "c", "d"),
        options = list(`style` = "btn-danger")
      ),
      verbatimTextOutput("res8")
    ),

    basicPanel(
      pickerInput(
        inputId = "id9", label = "Style individual options",
        choices = c("steelblue 150%", "right align + red", "bold", "background color"),
        choicesOpt = list(
          style = c("color: steelblue; font-size: 150%;", "color: firebrick; text-align: right;",
                    "font-weight: bold;",
                    "background: forestgreen; color: white;")
        )
      ),
      verbatimTextOutput("res9")
    ),

    basicPanel(
      pickerInput(
        inputId = "id19", label = "Style individual options",
        choices = paste("Badge", c("info", "success", "danger", "primary", "warning")),
        choicesOpt = list(
          content=sprintf(
            "<span class='label label-%s'>%s</span>", c("info", "success", "danger", "primary", "warning"),
            paste("Badge", c("info", "success", "danger", "primary", "warning"))
          )
        )
      ),
      verbatimTextOutput("res19")
    ),

    basicPanel(
      pickerInput(
        inputId = "id001", label = "width: 'auto'",
        choices = c("a", "b", "c", "ddddddddddddddddddddddddddd"), width = "auto"
      ),
      pickerInput(
        inputId = "id002", label = "width: 'fit'",
        choices = c("a", "b", "c", "ddddddddddddddddddddddddddd"), width = "fit"
      ),
      pickerInput(
        inputId = "id003", label = "width: '100px'",
        choices = c("a", "b", "c", "ddddddddddddddddddddddddddd"), width = "100px"
      ),
      pickerInput(
        inputId = "id004", label = "width: '75%'",
        choices = c("a", "b", "c", "ddddddddddddddddddddddddddd"), width = "75%"
      )
    ),

    basicPanel(
      pickerInput(
        inputId = "id10", label = "Glyphicon",
        choices = c("glyphicon-cog", "glyphicon-play", "glyphicon-ok-sign",
                    "glyphicon-arrow-right", "glyphicon-euro", "glyphicon-music"),
        choicesOpt = list(
          icon = c("glyphicon-cog", "glyphicon-play", "glyphicon-ok-sign",
                   "glyphicon-arrow-right", "glyphicon-euro", "glyphicon-music")
        )
      ),
      verbatimTextOutput("res10")
    ),

    basicPanel(
      pickerInput(
        inputId = "id11", label = "Subtext",
        choices = rownames(mtcars),
        choicesOpt = list(
          subtext = paste("mpg", mtcars$mpg, sep =": ")
        )
      ),
      verbatimTextOutput("res11")
    ),

    basicPanel(
      pickerInput(
        inputId = "id12", label = "Menu size (5 items visible)", choices = LETTERS,
        options = list(`size` = 5)
      ),
      verbatimTextOutput("res12")
    ),

    basicPanel(
      pickerInput(
        inputId = "id13", label = "Select/deselect all options", choices = LETTERS,
        options = list(`actions-box` = TRUE), multiple = TRUE
      ),
      verbatimTextOutput("res13")
    ),

    basicPanel(
      pickerInput(
        inputId = "id14", label = "c selected by default", choices = c("a", "b", "c", "d"),
        selected = "c"
      ),
      verbatimTextOutput("res14")
    ),

    # basicPanel(
    #   pickerInput(inputId = "id15", label = NULL, choices = NULL),
    #   verbatimTextOutput("res15")
    # ),

    basicPanel(
      pickerInput(inputId = "id16", label = "Update selected", choices = c("a", "b", "c", "d")),
      radioButtons(inputId = "update", label = "Update", choices = c("a", "b", "c", "d"), inline = TRUE),
      verbatimTextOutput("res16")
    ),

    basicPanel(
      pickerInput(inputId = "id17", label = "Update choices... BUG!!!", choices = c("a", "b", "c", "d")),
      radioButtons(inputId = "update2", label = "Update", choices = c("lower", "upper"), inline = TRUE),
      verbatimTextOutput("res17"),
      tags$button("test", onclick = "$('#id17').selectpicker('refresh');")
    ),

    basicPanel(
      pickerInput(inputId = "id18", label = "Inline", choices = c("a", "b", "c", "d"), inline = TRUE),
      verbatimTextOutput("res18")
    )
  )
)

.shinyWidgetGalleryFuns$tabPickerInput <- function() {
  tagList(
    tags$h1("Select Picker", class = "fw-bold text-primary"),
    tags$h5(
      "via ",
      tags$a(href = "https://github.com/snapappointments/bootstrap-select", "bootstrap-select")
    ),
    br(),

    fluidRow(
      column(
        width = 4,

        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Default",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Default",
              choices = c("a", "b", "c", "d"),
              options = pickerOptions(container = "body"),
              width = "100%"
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Options group",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Options group",
              choices = list(
                lower = c("a", "b", "c", "d"),
                upper = c("A", "B", "C", "D")
              ),
              options = pickerOptions(container = "body"),
              width = "100%"
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Multiple",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Multiple",
              choices = attr(UScitiesD, "Labels"),
              multiple = TRUE,
              options = pickerOptions(container = "body"),
              width = "100%"
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Live search",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Live search",
              choices = attr(UScitiesD, "Labels"),
              options = pickerOptions(container = "body", liveSearch = TRUE),
              width = "100%"
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Menu size",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Menu size (5 items visible)",
              choices = LETTERS,
              options = pickerOptions(container = "body", size = 5),
              width = "100%"
            )
          )
        )

      ),

      column(
        width = 4,

        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Placeholder",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Placeholder",
              choices = c("a", "b", "c", "d"),
              options = pickerOptions(container = "body", title = "This a placeholder"),
              width = "100%"
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Selected text format",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Selected text format (select >3 items)",
              choices = LETTERS,
              multiple = TRUE,
              options = pickerOptions(container = "body", selectedTextFormat = "count > 3"),
              width = "100%"
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Style : primary",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Style : primary",
              choices = c("a", "b", "c", "d"),
              options = pickerOptions(container = "body", style = "btn-outline-primary"),
              width = "100%"
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Style : danger",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Style : danger",
              choices = c("a", "b", "c", "d"),
              options = pickerOptions(container = "body", style = "btn-danger"),
              width = "100%"
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Style individual options",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Style individual options with HTML",
              choices = c("steelblue 150%", "right align + red", "bold", "background color"),
              choicesOpt = list(
                style = c(
                  "color: steelblue; font-size: 150%;",
                  "color: firebrick; text-align: right;",
                  "font-weight: bold;",
                  "background: forestgreen; color: white;"
                )
              ),
              options = pickerOptions(container = "body"),
              width = "100%"
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Style individual options (preserved)",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Style individual options with HTML",
              choices = c("steelblue 150%", "right align + red", "bold", "background color"),
              choicesOpt = list(
                content = c(
                  "<div style='color: steelblue; font-size: 150%;'>steelblue 150%</div>",
                  "<div style='color: firebrick; text-align: right;'>right align + red</div>",
                  "<div style='font-weight: bold;'>bold</div>",
                  "<div style='background: forestgreen; color: white; padding-left: 5px;'>background color</div>"
                )
              ),
              options = pickerOptions(container = "body"),
              width = "100%"
            )
          )
        )

      ),

      column(
        width = 4,

        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Icons",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "FontAwesome icons",
              choices = c(
                "fa-gear",
                "fa-play",
                "fa-check",
                "fa-arrow-right",
                "fa-euro-sign",
                "fa-music"
              ),
              choicesOpt = list(
                icon = c(
                  "fa-gear",
                  "fa-play",
                  "fa-check",
                  "fa-arrow-right",
                  "fa-euro-sign",
                  "fa-music"
                )
              ),
              options = pickerOptions(container = "body", iconBase = "fas"),
              width = "100%"
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Subtext",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Subtext",
              choices = rownames(mtcars),
              choicesOpt = list(
                subtext = paste("mpg", mtcars$mpg, sep = ": ")
              ),
              options = pickerOptions(container = "body"),
              width = "100%"
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Select/deselect all",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Select/deselect all options",
              choices = LETTERS,
              multiple = TRUE,
              options = pickerOptions(container = "body", actionsBox = TRUE),
              width = "100%"
            )
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Update choices",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = pickerInput,
            args = list(
              inputId = "uppickerIcons",
              label = "Glyphicon <> FontAwesome",
              choices = c(
                "glyphicon-arrow-right / fa-arrow-right",
                "glyphicon-cog / fa-gear",
                "glyphicon-play / fa-play",
                "glyphicon-ok-sign / fa-check",
                "glyphicon-euro / fa-eur",
                "glyphicon-music / fa-music"
              ),
              choicesOpt = list(
                icon = c(
                  "glyphicon glyphicon-arrow-right",
                  "glyphicon glyphicon-cog",
                  "glyphicon glyphicon-play",
                  "glyphicon glyphicon-ok-sign",
                  "glyphicon glyphicon-euro",
                  "glyphicon glyphicon-music"
                )
              ),
              options = pickerOptions(iconBase = "", container = "body"),
              width = "100%"
            )
          ),
          br(),
          radioButtons(
            inputId = "uppickerIconsRadio",
            label = "Update with Icons",
            choices = c("Glyphicon", "FontAwesome"),
            inline = TRUE
          )
        )

      )

    )
  )
}

#  ------------------------------------------------------------------------
#
# Title : shinyWidgets Gallery - global
#    By : Victor
#  Date : 2020-12-01
#
#  ------------------------------------------------------------------------


library(htmltools)
library(bslib)
library(shinyWidgets)

if (any(ls(".GlobalEnv") %in% ls("package:shinyWidgets")))
  warning("Some function(s) from GlobalEnv will override those from shinyWidgets")

# ids <- paste0("Id", sprintf("%03d", 1:81))
.shinyWidgetGalleryId <- 1
# idss <- ids



# Funs --------------------------------------------------------------------

# Widget wrapper ----

.shinyWidgetGalleryFuns <- new.env()

.shinyWidgetGalleryFuns$widget_wrapper <- function(fun, args){
  raw <- paste0(
    deparse(substitute(fun)),
    gsub(
      pattern = "^list", replacement = "",
      x = paste(deparse(substitute(args)), collapse = "\n")
    )
  )
  raw <- gsub(pattern = "ID\\(\\.shinyWidgetGalleryId\\)", replacement = paste0("\"", args$inputId, "\""), x = raw)

  formatted <- sub(pattern = "\\(", replacement = "\\(\n   ", x = raw)
  formatted <- gsub(pattern = "\\)$", replacement = "\n\\)", x = formatted)
  formatted <- gsub(pattern = ",(\\s[[:graph:]]+\\s=)", replacement = ",\n  \\1", x = formatted)
  formatted <- gsub(pattern = "list\\(", replacement = "list\\(\n      ", x = formatted)
  formatted <- trimws(formatted)

  htmltools::tagList(
    do.call(fun, args), htmltools::hr(),
    htmltools::tags$b("Value :"),
    shiny::verbatimTextOutput(outputId = paste0("res", args$inputId)),
    tags$a(
      icon("code"),
      "Show code",
      `data-bs-toggle` = "collapse",
      href = paste0("#showcode", args$inputId)
    ),
    htmltools::tags$div(
      class="collapse", id=paste0("showcode", args$inputId),
      .shinyWidgetGalleryFuns$rCodeContainer(
        id=paste0("code", args$inputId),
        formatted
      )
    )
  )
}

.shinyWidgetGalleryFuns$box_wrapper <- function(title, ..., footer = NULL) {
  bslib::card(
    if (!is.null(title)) bslib::card_header(title, class = "bg-primary text-light"),
    bslib::card_body(...),
    if (!is.null(footer)) bslib::card_footer(footer)
  )
}

.shinyWidgetGalleryFuns$pb_code <- function(id, ui, server) {
  htmltools::tagList(
    tags$a(
      icon("code"),
      "Show code",
      `data-bs-toggle` = "collapse",
      href = paste0("#showcode", id)
    ),
    htmltools::tags$div(
      class = "collapse",
      id = paste0("showcode", id),
      .shinyWidgetGalleryFuns$rCodeContainer(
        id=paste0("code", id),
        paste(
          "# ui",
          ui,
          "# server",
          server,
          sep = "\n"
        )
      )
    )
  )
}



# Highlight functions ----

.shinyWidgetGalleryFuns$injectHighlightHandler <- function() {
  code <- "
  Shiny.addCustomMessageHandler('highlight-code', function(message) {
  var id = message['id'];
  setTimeout(function() {
  var el = document.getElementById(id);
  hljs.highlightBlock(el);
  }, 100);
  });
  "
  htmltools::tags$script(code)
}

.shinyWidgetGalleryFuns$includeHighlightJs <- function() {
  resources <- system.file("www/shared/highlight", package = "shiny")
  list(
    htmltools::includeScript(file.path(resources, "highlight.pack.js")),
    htmltools::includeCSS(file.path(resources, "rstudio.css")),
    .shinyWidgetGalleryFuns$injectHighlightHandler()
  )
}

.shinyWidgetGalleryFuns$highlightCode <- function(session, id) {
  session$sendCustomMessage("highlight-code", list(id = id))
}

.shinyWidgetGalleryFuns$rCodeContainer <- function(...) {
  code <- htmltools::HTML(as.character(tags$code(class = "language-r", ...)))
  htmltools::tags$div(htmltools::tags$pre(code))
}

.shinyWidgetGalleryFuns$renderCode <- function(expr, env = parent.frame(), quoted = FALSE) {
  func <- NULL
  shiny::installExprFunction(expr, "func", env, quoted)
  shiny::markRenderFunction(shiny::textOutput, function() {
    paste(func(), collapse = "\n")
  })
}

ID <- function(.shinyWidgetGalleryId) {
  tmp <- paste0("Id", sprintf("%03d", .shinyWidgetGalleryId))
  .shinyWidgetGalleryId <<- .shinyWidgetGalleryId + 1
  return(tmp)
}



# load tabs UI
for (tab in list.files("tabs/")) {
  source(file = file.path("tabs", tab))
}
rm(tab)



# Message for tests

message("Running shinyWidgets gallery...")

.shinyWidgetGalleryFuns$tabAwesome <- function() {
  tagList(
    tags$h1("Awesome Checkboxes And Radios", class = "fw-bold text-primary"),
    tags$h5(
      "via ",
      tags$a(href = "http://flatlogic.github.io/awesome-bootstrap-checkbox/demo/", "awesome-bootstrap-checkbox")
    ),
    br(),

    fluidRow(
      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Shiny default",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = checkboxInput,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "A single checkbox", value = TRUE)
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Shiny default",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = checkboxGroupInput,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Checkboxes", choices = c("A", "B", "C"), selected = "A")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Shiny default",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = radioButtons,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Radio buttons", choices = c("A", "B", "C"))
          )
        )
      ),

      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Single",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = awesomeCheckbox,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "A single checkbox", value = TRUE)
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Checkbox group",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = awesomeCheckboxGroup,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Checkboxes", choices = c("A", "B", "C"), selected = "A")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Radio buttons",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = awesomeRadio,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Radio buttons", choices = c("A", "B", "C"), selected = "A")
          )
        )
      ),

      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Another color",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = awesomeCheckbox,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "A single checkbox", value = TRUE, status = "info")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Inline & danger",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = awesomeCheckboxGroup,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Checkboxes", choices = c("A", "B", "C"), selected = "A", inline = TRUE, status = "danger")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Inline & success",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = awesomeRadio,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Radio buttons", choices = c("A", "B", "C"), selected = "A", inline = TRUE, status = "success")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Inline & checkbox styled",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = awesomeRadio,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Radio buttons", choices = c("A", "B", "C"), selected = "A", inline = TRUE, checkbox =  TRUE)
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Update selected",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = awesomeRadio,
            args = list(inputId = "upAwesomeRadio", label = "Radio buttons", choices = c("A", "B", "C"), selected = "A", inline = TRUE)
          ),
          br(),
          tags$p("Click to update :"),
          actionGroupButtons(inputIds = c("upAwesomeRadioA", "upAwesomeRadioB", "upAwesomeRadioC"), labels = c("A", "B", "C"))
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Update choices",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = awesomeCheckboxGroup,
            args = list(inputId = "upAwesomeCheckbox", label = "Checkbox group", choices = c("A", "B", "C"), selected = "A", inline = TRUE, status = "warning")
          ),
          br(),
          tags$p("Click to update :"),
          actionGroupButtons(inputIds = c("upAwesomeCheckbox1", "upAwesomeCheckbox2"), labels = c("tolower & success", "TOUPPER & warning"))
        )
      )
    )
  )
}

.shinyWidgetGalleryFuns$tabOtherStuff <- function() {
  code_dropdownButton <- readLines(con = "code_dropdownButton.R")
  code_dropdownButton <- paste(code_dropdownButton, collapse = "\n")
  code_dropdown <- readLines(con = "code_dropdown.R")
  code_dropdown <- paste(code_dropdown, collapse = "\n")
  code_sa <- readLines(con = "code_sa.R")
  code_sa <- paste(code_sa, collapse = "\n")
  tagList(
    tags$h1("Other widgets", class = "fw-bold text-primary"),

    fluidRow(
      column(
        width = 8,

        bslib::card(
          bslib::card_header("Dropdown Button", class = "bg-primary text-light"),
          bslib::card_body(
            dropdownButton(
              tags$h3("List of Inputs"),
              selectInput(inputId = "xcol", label = "X Variable", choices = names(iris)),
              selectInput(inputId = "ycol", label = "Y Variable", choices = names(iris), selected = names(iris)[[2]]),
              sliderInput(inputId = "clusters", label = "Cluster count", value = 3, min = 1, max = 9),
              circle = TRUE, status = "danger", icon = icon("gear"), width = "300px",
              tooltip = tooltipOptions(title = "Click to see inputs !")
            ),
            plotOutput(outputId = "plot1"),
            tags$p("if you want to hide inputs to focus on a plot.."),
            tags$a(
              icon("code"),
              "Show code",
              `data-bs-toggle` = "collapse",
              href = "#showcode_dropdownButton"
            ),
            tags$div(
              class = "collapse",
              id = "showcode_dropdownButton",
              .shinyWidgetGalleryFuns$rCodeContainer(
                id="code_dropdownButton",
                code_dropdownButton
              )
            )
          )
        ),

        bslib::card(
          bslib::card_header("Dropdown (bis)", class = "bg-primary text-light"),
          bslib::card_body(
            dropdown(
              tags$h3("List of Input"),
              pickerInput(inputId = "xcol2", label = "X Variable", choices = names(iris), options = list(`style` = "btn-info")),
              pickerInput(inputId = "ycol2", label = "Y Variable", choices = names(iris), selected = names(iris)[[2]], options = list(`style` = "btn-warning")),
              sliderInput(inputId = "clusters2", label = "Cluster count", value = 3, min = 1, max = 9),
              style = "unite", icon = icon("gear"), status = "danger", width = "300px",
              animate = animateOptions(
                enter = animations$fading_entrances$fadeInLeftBig,
                exit = animations$fading_exits$fadeOutRightBig
              )
            ),
            plotOutput(outputId = "plot2"),
            tags$p("In this version you can add animations and pickerInput will work in it."),
            tags$a(
              icon("code"),
              "Show code",
              `data-bs-toggle` = "collapse",
              href = "#showcode_dropdown"
            ),
            tags$div(
              class = "collapse",
              id = "showcode_dropdown",
              .shinyWidgetGalleryFuns$rCodeContainer(
                id="code_dropdown",
                code_dropdown
              )
            )
          )
        )
      ),

      column(
        width = 4,
        bslib::card(
          bslib::card_header("Sweet Alert", class = "bg-primary text-light"),
          tags$span(
            "via ",
            tags$a(href = "https://github.com/sweetalert2/sweetalert2", "sweetalert2")
          ), br(), br(),
          fluidRow(
            column(
              width = 6,
              actionButton(inputId = "success", label = "Success !", width = "100%", class = "btn-success"),
              br(), br(),
              actionButton(inputId = "info", label = "Info", width = "100%", class = "btn-info")
              # receiveSweetAlert(messageId = "infomessage")
            ),
            column(
              width = 6,
              actionButton(inputId = "error", label = "Error", width = "100%", class = "btn-danger"),
              br(), br(),
              actionButton(inputId = "warning", label = "Warning", width = "100%", class = "btn-warning")
            )
          ),
          br(),
          tags$a(
            icon("code"),
            "Show code",
            `data-bs-toggle` = "collapse",
            href = "#showcodeSA"
          ),
          tags$div(
            class = "collapse",
            id = "showcodeSA",
            .shinyWidgetGalleryFuns$rCodeContainer(
              id = "codeSA",
              code_sa
            )
          )
        ),
        bslib::card(
          bslib::card_header("Confirmation dialog", class = "bg-primary text-light"),
          bslib::card_body(
            actionButton(inputId = "launch_confirmation", label = "Ask for confirmation"),
            tags$br(),
            verbatimTextOutput(outputId = "res_confirmation")
          )
        )
      )
    )
  )

}

# colorSelector example ---------------------------------------------------


library("shiny")
library("shinyWidgets")
library("scales")



# ColorBrewer palette
choices_brewer <- list(
  "Blues" = brewer_pal(palette = "Blues")(9),
  "Greens" = brewer_pal(palette = "Greens")(9),
  "Reds" = brewer_pal(palette = "Reds")(9),
  "Oranges" = brewer_pal(palette = "Oranges")(9),
  "Purples" = brewer_pal(palette = "Purples")(9),
  "Greys" = brewer_pal(palette = "Greys")(9),
  "Dark2" = brewer_pal(palette = "Dark2")(8),
  "Set1" = brewer_pal(palette = "Set1")(8),
  "Paired" = brewer_pal(palette = "Paired")(10)
)


# Viridis palette (we remove the alpha from hex code because it's not supported in all browsers)
col2Hex <- function(col) {
  mat <- grDevices::col2rgb(col, alpha = TRUE)
  grDevices::rgb(mat[1, ]/255, mat[2, ]/255, mat[3,]/255)
}

choices_viridis <- list(
  "viridis" = col2Hex(viridis_pal(option = "viridis")(10)),
  "magma" = col2Hex(viridis_pal(option = "magma")(10)),
  "inferno" = col2Hex(viridis_pal(option = "inferno")(10)),
  "plasma" = col2Hex(viridis_pal(option = "plasma")(10)),
  "cividis" = col2Hex(viridis_pal(option = "cividis")(10))
)


# Classic R colors (we remove the nuance becaure there aren't valid css colors)
choices_colors <- colors(distinct = TRUE)
choices_colors <- choices_colors[!grepl(pattern = "\\d$", x = choices_colors)]


ui <- fluidPage(
  fluidRow(
    column(
      width = 4,
      colorSelectorInput(
        inputId = "mycolor1",
        label = "Pick a color :",
        choices = c("steelblue", "cornflowerblue", "firebrick", "palegoldenrod", "forestgreen")
      ),
      verbatimTextOutput("result1")
    ),
    column(
      width = 4,
      colorSelectorInput(
        inputId = "mycolor2",
        label = "Pick a color :",
        choices = choices_brewer,
        display_label = TRUE
      ),
      verbatimTextOutput("result2")
    ),
    column(
      width = 4,
      colorSelectorInput(
        inputId = "mycolor3",
        label = "Pick a color :",
        choices = choices_viridis
      ),
      verbatimTextOutput("result3")
    )
  ),
  fluidRow(
    column(
      width = 4,
      colorSelectorInput(
        inputId = "mycolor4",
        label = "Pick a color :",
        choices = choices_colors
      ),
      verbatimTextOutput("result4")
    )
  )
)

server <- function(input, output, session) {
  output$result1 <- renderPrint({
    input$mycolor1
  })
  output$result2 <- renderPrint({
    input$mycolor2
  })
  output$result3 <- renderPrint({
    input$mycolor3
  })
  output$result4 <- renderPrint({
    input$mycolor4
  })
}

shinyApp(ui = ui, server = server)

# airDatepicker examples --------------------------------------------------

library(shiny)
library(shinyWidgets)




# ui ----

ui <- fluidPage(

  # theme = bslib::bs_theme(version = 5L),

  tags$h2("Air datepicker examples"),
  tags$br(),

  fluidRow(

    column(
      width = 6,

      airDatepickerInput(
        inputId = "default",
        label = "First example:"
      ),
      verbatimTextOutput(outputId = "res_default"),

      airDatepickerInput(
        inputId = "multiple",
        label = "Select multiple dates (max 3):",
        placeholder = "You can pick 3 dates",
        multiple = 3,
        clearButton = TRUE
      ),
      verbatimTextOutput(outputId = "res_multiple"),

      airDatepickerInput(
        inputId = "range",
        label = "Select range of dates:",
        range = TRUE,
        value = c(Sys.Date()-7, Sys.Date())
      ),
      verbatimTextOutput(outputId = "res_range"),

      airDatepickerInput(
        inputId = "close",
        label = "Update when closing:",
        value = Sys.Date(),
        position = "right top",
        update_on = "close",
        addon = "left"
      ),
      verbatimTextOutput(outputId = "res_close"),

      airDatepickerInput(
        inputId = "french",
        label = "En fran\u00e7ais:",
        value = Sys.Date(),
        dateFormat = "dd/MM/yyyy",
        language = "fr"
      ),
      verbatimTextOutput(outputId = "res_french"),

      airDatepickerInput(
        inputId = "disable",
        label = "Disable some dates:",
        value = Sys.Date(),
        position = "top left",
        disabledDates = Sys.Date() + c(-9, -5, 2, 5, 8)
      ),
      verbatimTextOutput(outputId = "res_disable")

    ),

    column(
      width = 6,

      airDatepickerInput(
        inputId = "defaultValue",
        label = paste("With a default date:", Sys.Date() - 7),
        value = Sys.Date() - 7
      ),
      verbatimTextOutput(outputId = "res_defaultValue"),

      airDatepickerInput(
        inputId = "month",
        label = "Select months:",
        view = "months",
        minView = "months",
        dateFormat = "MM yyyy",
        monthsField = "months"
      ),
      verbatimTextOutput(outputId = "res_month"),

      airDatepickerInput(
        inputId = "minmax",
        label = "Min & max dates:",
        minDate = "2018-01-10",
        maxDate = "2018-01-21"
      ),
      verbatimTextOutput(outputId = "res_minmax"),

      airDatepickerInput(
        inputId = "inline",
        label = "Inline:",
        inline = TRUE
      ),
      verbatimTextOutput(outputId = "res_inline")

    )

  )
)

# server ----

server <- function(input, output, session) {

  output$res_default <- renderPrint( str(input$default) )
  output$res_defaultValue <- renderPrint( str(input$defaultValue) )
  output$res_multiple <- renderPrint( str(input$multiple) )
  output$res_month <- renderPrint( str(input$month) )
  output$res_range <- renderPrint( str(input$range) )
  output$res_minmax <- renderPrint({ str(input$minmax) })
  output$res_close <- renderPrint({ str(input$close) })
  output$res_inline <- renderPrint({ str(input$inline) })
  output$res_french <- renderPrint({ str(input$french) })
  output$res_disable <- renderPrint({ str(input$disable) })

}

# app ----

shinyApp(ui = ui, server = server)

# ------------------------------------------------------------------------ #
#
# Descriptif : Bootstrap Switch
#     Detail : http://www.bootstrap-switch.org/examples.html
#
#
# Auteur : Victor PERRIER
#
# Date creation : 01/07/2016
# Date modification : 01/07/2016
#
# Version 1.0
#
# ------------------------------------------------------------------------ #



library("shiny")
library("shinyWidgets")

function(input, output, session) {

  lapply(
    X = seq_len(8),
    FUN = function(i) {
      output[[paste0("res", i)]] <- renderPrint({
        input[[paste0("switch", i)]]
      })
    }
  )

  output$resbox1 <- renderPrint({
    input$box1
  })


  observeEvent(input$vrai, {
    updateSwitchInput(session = session, inputId = "switchUp", value = TRUE)
  })
  observeEvent(input$faux, {
    updateSwitchInput(session = session, inputId = "switchUp", value = FALSE)
  })
  output$resup1 <- renderPrint({
    input$switchUp
  })
}

library(shiny)
library(shinyWidgets)

ui <- fluidPage(
  theme = bslib::bs_theme(5),
  tags$h2("Calendar Pro Input: disable/enable days"),
  fluidRow(
    column(
      width = 6,
      calendarProInput(
        inputId = "cal1",
        label = "Disable past:",
        placeholder = "Select a date",
        disableDatesPast = TRUE,
        width = "100%"
      ),
      verbatimTextOutput("res1"),
      calendarProInput(
        inputId = "cal3",
        label = "Disable week-ends:",
        disableWeekdays = c(0, 6),
        width = "100%"
      ),
      verbatimTextOutput("res3"),
      calendarProInput(
        inputId = "cal5",
        label = "Disable wednesdays:",
        disableWeekdays = 3,
        width = "100%"
      ),
      verbatimTextOutput("res5"),
      calendarProInput(
        inputId = "cal7",
        label = "Set range of selectable dates:",
        placeholder = "Select a date",
        displayDateMin = Sys.Date() - 14,
        displayDateMax = Sys.Date() + 7,
        width = "100%"
      ),
      verbatimTextOutput("res7")
    ),
    column(
      width = 6,
      calendarProInput(
        inputId = "cal2",
        label = "Disable select range with gaps (cannot select range with today included):",
        mode = "multiple-ranged",
        disableDatesGaps = TRUE,
        disableDates = Sys.Date(),
        positionToInput = c("bottom", "left"),
        width = "100%"
      ),
      verbatimTextOutput("res2"),
      calendarProInput(
        inputId = "cal4",
        label = "Disable days:",
        disableDates = c(Sys.Date() + c(-5, -2, 3, 6, 7, 9, 14)),
        positionToInput = c("bottom", "left"),
        width = "100%"
      ),
      verbatimTextOutput("res4"),
      calendarProInput(
        inputId = "cal6",
        label = "Disable range of days (today -/+ 3):",
        disableDates = paste(Sys.Date() - 3, Sys.Date() + 3, sep = ":"),
        positionToInput = c("bottom", "left"),
        width = "100%"
      ),
      verbatimTextOutput("res6"),
      calendarProInput(
        inputId = "cal8",
        label = "Enable specifics days:",
        disableAllDates = TRUE,
        enableDates = c(Sys.Date() + c(-5, -2, 3, 6, 7, 9, 14)),
        positionToInput = c("bottom", "left"),
        width = "100%"
      ),
      verbatimTextOutput("res8")
    )
  )
)

server <- function(input, output, session) {

  output$res1 <- renderPrint(input$cal1)
  output$res2 <- renderPrint(input$cal2)
  output$res3 <- renderPrint(input$cal3)
  output$res4 <- renderPrint(input$cal4)
  output$res5 <- renderPrint(input$cal5)
  output$res6 <- renderPrint(input$cal6)
  output$res7 <- renderPrint(input$cal7)
  output$res8 <- renderPrint(input$cal8)

}

if (interactive())
  shinyApp(ui, server)

# ------------------------------------------------------------------------ #
#
# Descriptif : Radio Group Buttons : fonctions R
#     Detail : http://getbootstrap.com/javascript/#buttons-checkbox-radio
#
#
# Auteur : Victor PERRIER
#
# Date creation : 01/07/2016
# Date modification : 01/07/2016
#
# Version 1.0
#
# ------------------------------------------------------------------------ #



# radioGroupButtons ----------------------------------------------------

library("shiny")
library("shinyWidgets")

fluidPage(
  theme = bslib::bs_theme(version = 4),

  tags$h1("radioGroupButtons", style = "color: steelblue;"),
  tags$h3("Des radio en forme de boutons."),
  br(),
  tags$h4("Usage classique"),
  fluidRow(
    column(
      width = 4,
      radioGroupButtons(
        inputId = "test1",
        label = "Juste avec les labels",
        choices = c("Choice 1", "Choice 2", "Choice 3")
      ),
      verbatimTextOutput(outputId = "res1")
    ),
    column(
      width = 4,
      radioGroupButtons(
        inputId = "test2",
        label = "Avec des values différentes des labels",
        choices = c("Choice 1" = "A", "Choice 2" = "B", "Choice 3" = "C")
      ),
      verbatimTextOutput(outputId = "res2")
    ),
    column(
      width = 4,
      radioGroupButtons(
        inputId = "test3",
        label = "Avec des Choice par défauts",
        choices = c("Choice 1" = "A", "Choice 2" = "B", "Choice 3" = "C", "Choice 4" = "D"),
        selected = "B"
      ),
      verbatimTextOutput(outputId = "res3")
    )
  ),

  br(), br(),

  tags$h4("Avec des statuts bootstrap"),
  fluidRow(
    column(
      width = 4,
      radioGroupButtons(
        inputId = "test4",
        label = "Juste avec les labels",
        choices = c("Choice 1", "Choice 2", "Choice 3"),
        status = "primary"
      ),
      verbatimTextOutput(outputId = "res4")
    ),
    column(
      width = 4,
      radioGroupButtons(
        inputId = "test5",
        label = "Avec des values différentes des labels",
        choices = c("Choice 1" = "A", "Choice 2" = "B", "Choice 3" = "C"),
        status = "danger"
      ),
      verbatimTextOutput(outputId = "res5")
    ),
    column(
      width = 4,
      radioGroupButtons(
        inputId = "test6", label = "Avec des Choice par défauts",
        choices = c("Choice 1" = "A", "Choice 2" = "B", "Choice 3" = "C", "Choice 4" = "D"),
        selected = "B",
        status = "success"
      ),
      verbatimTextOutput(outputId = "res6")
    )
  ),

  br(), br(),

  tags$h4("Avec effets de style"),
  fluidRow(
    column(
      width = 4,
      radioGroupButtons(
        inputId = "test7",
        label = "Button size :",
        choices = c("Choice 1", "Choice 2"),
        size = "lg"
      ),
      verbatimTextOutput(outputId = "res7"),

      radioGroupButtons(
        inputId = "test11",
        label = "Icon for checked button:",
        choices = c("Choice 1", "Choice 2", "Choice 3"),
        checkIcon = list(yes = icon("ok", lib = "glyphicon"))
      ),
      verbatimTextOutput(outputId = "res11")
    ),
    column(
      width = 4,
      radioGroupButtons(
        inputId = "test8",
        label = "Vertical buttons",
        choices = c("Choice 1", "Choice 2", "Choice 3"),
        direction = "vertical",
        width = "100%"
      ),
      verbatimTextOutput(outputId = "res8"),

      radioGroupButtons(
        inputId = "test13",
        label = "Icon for checked button:",
        choices = c("Choice 1", "Choice 2", "Choice 3"),
        checkIcon = list(
          yes = icon("check"),
          no = icon("xmark")
        )
      ),
      verbatimTextOutput(outputId = "res13")
    ),
    column(
      width = 4,
      radioGroupButtons(
        inputId = "test9",
        label = "Full width:",
        choices = c("Choice 1", "Choice 2"),
        justified = TRUE
      ),
      verbatimTextOutput(outputId = "res9"),

      radioGroupButtons(
        inputId = "test14",
        label = "Individual buttons:",
        choices = c("Choice 1", "Choice 2", "Choice 3"),
        individual = TRUE
      ),
      verbatimTextOutput(outputId = "res14")
    )
  ),

  br(), br(),

  tags$h4("Update !"),
  fluidRow(
    column(
      width = 4,
      radioGroupButtons(
        inputId = "test10",
        choices = c("A", "B", "C", "D")
      ),
      verbatimTextOutput(outputId = "res10")
    ),
    column(
      width = 4,
      selectizeInput(inputId = "maj", label = "Update radioGroupButtons", choices = c("Aucun", "A", "B", "C", "D"), selected = "Aucun")
    )
  ), br(), br(),
  tags$h4(icon("thumbs-up", "fa-2x"), "Icons !"),
  fluidRow(
    column(
      width = 12,
      tags$div(
        style = "width: 100%;",
        radioGroupButtons(
          inputId = "test12",
          choices = c(
            "<i class='fa fa-bar-chart'></i>" = 1,
            "<i class='fa fa-bar-chart'></i> (stacked)" = 2,
            "<i class='fa fa-bar-chart'></i> (dodged)" = 3,
            "<i class='fa fa-pie-chart'></i>" = 4
          ), justified = TRUE
        ),
        verbatimTextOutput(outputId = "res12")
      )
    )
  ), br(), br(),

  fluidRow(
    column(
      width = 4,
      tags$h4("radioButtons de shiny"),
      radioButtons(inputId = "verif", label = "Classique", choices = c("Choice 1", "Choice 2", "Choice 3")),
      verbatimTextOutput(outputId = "resverif")
    ),
    column(
      width = 4,
      tags$h4("Conflicts with DT"),
      dataTableOutput(outputId = "verifDT")
    )
  )
)

# ------------------------------------------------------------------------ #
#
# Descriptif : Checkbox Group Buttons : fonctions R
#     Detail : http://getbootstrap.com/javascript/#buttons-checkbox-radio
#
#
# Auteur : Victor PERRIER
#
# Date creation : 01/07/2016
# Date modification : 01/07/2016
#
# Version 1.0
#
# ------------------------------------------------------------------------ #



# checkboxGroupButtons ----------------------------------------------------

library(shiny)
library(shinyWidgets)

fluidPage(
  theme = bslib::bs_theme(version = 5),

  tags$h1("checkboxGroupButtons", style = "color: steelblue;"),
  tags$h3("Des checkbox en forme de boutons."),
  br(),

  tags$h4("Usage classique"),
  fluidRow(
    column(
      width = 4,
      checkboxGroupButtons(
        inputId = "test1",
        label = "Juste avec les labels",
        choices = c("Choice 1", "Choice 2", "Choice 3")
      ),
      verbatimTextOutput(outputId = "res1")
    ),
    column(
      width = 4,
      checkboxGroupButtons(
        inputId = "test2",
        label = "Avec des values différentes des labels",
        choices = c(
          "Choice 1" = "A",
          "Choice 2" = "B",
          "Choice 3" = "C"
        )
      ),
      verbatimTextOutput(outputId = "res2")
    ),
    column(
      width = 4,
      checkboxGroupButtons(
        inputId = "test3",
        label = "Avec des Choice par défauts",
        choices = c(
          "Choice 1" = "A",
          "Choice 2" = "B",
          "Choice 3" = "C",
          "Choice 4" = "D"
        ),
        selected = c("B", "D")
      ),
      verbatimTextOutput(outputId = "res3")
    )
  ),

  br(),
  br(),

  tags$h4("Avec des statuts bootstrap"),
  fluidRow(
    column(
      width = 4,
      checkboxGroupButtons(
        inputId = "test4",
        label = "Juste avec les labels",
        choices = c("Choice 1", "Choice 2", "Choice 3"),
        status = "primary"
      ),
      verbatimTextOutput(outputId = "res4")
    ),
    column(
      width = 4,
      checkboxGroupButtons(
        inputId = "test5",
        label = "Avec des values différentes des labels",
        choices = c(
          "Choice 1" = "A",
          "Choice 2" = "B",
          "Choice 3" = "C"
        ),
        status = "danger"
      ),
      verbatimTextOutput(outputId = "res5")
    ),
    column(
      width = 4,
      checkboxGroupButtons(
        inputId = "test6",
        label = "Avec des choix par défauts",
        choices = c(
          "Choice 1" = "A",
          "Choice 2" = "B",
          "Choice 3" = "C",
          "Choice 4" = "D"
        ),
        selected = c("B", "D"),
        status = "success"
      ),
      verbatimTextOutput(outputId = "res6")
    )
  ),

  br(),
  br(),

  tags$h4("Avec effets de style"),
  fluidRow(
    column(
      width = 4,
      checkboxGroupButtons(
        inputId = "test7",
        label = "Taille",
        choices = c("Choice 1", "Choice 2"),
        size = "lg"
      ),
      verbatimTextOutput(outputId = "res7"),

      checkboxGroupButtons(
        inputId = "test11",
        label = "Icon for checked button:",
        choices = c("A", "B", "C", "D"),
        checkIcon = list(yes = icon("ok", lib = "glyphicon"))
      ),
      verbatimTextOutput(outputId = "res11")
    ),
    column(
      width = 4,
      checkboxGroupButtons(
        inputId = "test8",
        label = "Vertical :",
        choices = c("Choice 1", "Choice 2", "Choice 3"),
        direction = "vertical",
        width = "100%"
      ),
      verbatimTextOutput(outputId = "res8"),

      checkboxGroupButtons(
        inputId = "test13",
        label = "Icon for checked button:",
        choices = c("Choice 1", "Choice 2", "Choice 3"),
        checkIcon = list(
          yes = icon("check"),
          no = icon("xmark")
        )
      ),
      verbatimTextOutput(outputId = "res13")
    ),
    column(
      width = 4,
      checkboxGroupButtons(
        inputId = "test9",
        label = "Fullwidth:",
        choices = c("Choice 1", "Choice 2"),
        justified = TRUE
      ),
      verbatimTextOutput(outputId = "res9"),

      checkboxGroupButtons(
        inputId = "test14",
        label = "Individual buttons:",
        choices = c("Choice 1", "Choice 2", "Choice 3"),
        individual = TRUE
      ),
      verbatimTextOutput(outputId = "res14")
    )
  ),

  br(),
  br(),

  tags$h4("Update !"),
  fluidRow(
    column(
      width = 4,
      checkboxGroupButtons(inputId = "test10", choices = c("A", "B", "C", "D")),
      verbatimTextOutput(outputId = "res10")
    ),
    column(
      width = 4,
      selectizeInput(
        inputId = "maj",
        label = "Update checkboxGroupButtons",
        choices = c("Aucun", "A", "B", "C", "D"),
        selected = "Aucun"
      )
    )
  ),
  br(),
  br(),
  tags$h4(icon("thumbs-up", "fa-2x"), "Icons !"),
  fluidRow(column(
    width = 12,
    tags$div(
      style = "width: 100%;",
      checkboxGroupButtons(
        inputId = "test12",
        choices = c(
          "<i class='fa fa-bar-chart'></i>" = 1,
          "<i class='fa fa-bar-chart'></i> (stacked)" = 2,
          "<i class='fa fa-bar-chart'></i> (dodged)" = 3,
          "<i class='fa fa-pie-chart'></i>" = 4
        ),
        justified = TRUE
      ),
      verbatimTextOutput(outputId = "res12")
    )
  )),

  br(),
  br(),

  fluidRow(
    column(
      width = 4,
      tags$h4("checkboxGroupInput de shiny"),
      checkboxGroupInput(
        inputId = "verif",
        label = "Classique",
        choices = c("Choice 1", "Choice 2", "Choice 3")
      ),
      verbatimTextOutput(outputId = "resverif")
    ),
    column(
      width = 4,
      tags$h4("Conflicts with DT"),
      dataTableOutput(outputId = "verifDT")
    )
  )
)

library(shiny)
library(shinyWidgets)

ui <- fluidPage(
  html_dependency_winbox(),
  actionButton(inputId = "show1", label = "Show WinBox"),
  actionButton(inputId = "show2", label = "Show WinBox as modal")
)

server <- function(input, output, session) {

  observeEvent(input$show1, {
    WinBox(
      title = "Custom background color and border",
      ui = tagList(
        tags$h2("Hello from WinBox!"),
        "Text content of winbox."
      ),
      options = wbOptions(
        background = "#112446",
        border = "0.5em",
        x = "center",
        y = "center",
        width = "50%",
        height = "50%"
      )
    )
  })

  observeEvent(input$show2, {
    WinBox(
      title = "WinBox as modal",
      ui = tagList(
        tags$h2("Hello from WinBox!"),
        "Text content of winbox."
      ),
      options = wbOptions(modal = TRUE)
    )
  })

}

if (interactive())
  shinyApp(ui, server)

library("shiny")
library("shinyWidgets")


ui <- function(request) {
  fluidPage(
    tags$h1("shinyWidgets - bookmarking"),
    textInput(inputId = "txt", label = "Text"),
    switchInput(inputId = "swh", label = "Switch"),
    checkboxInput(inputId = "chk", label = "Checkbox"),
    bookmarkButton()
  )
}

server <- function(input, output, session) {

}

enableBookmarking("url")

shinyApp(ui, server)

library(shiny)
library(shinyWidgets)

ui <- fluidPage(
  html_dependency_winbox(),
  actionButton(inputId = "show", label = "Show WinBox")
)

server <- function(input, output, session) {

  observeEvent(input$show, {
    WinBox(
      title = "Custom controls",
      ui = tagList(
        tags$h2("Hello from WinBox!"),
        "Text content of winbox."
      ),
      controls = wbControls(
        min = FALSE,
        max = FALSE,
        resize = FALSE
      )
    )
  })

}

if (interactive())
  shinyApp(ui, server)

library(shiny)
library(shinyWidgets)

ui <- fluidPage(
  tags$h2("Exemple spinners"),
  actionButton(inputId = "refresh", label = "Refresh", width = "100%"),
  fluidRow(
    column(
      width = 5, offset = 1,
      addSpinner(plotOutput("plot1"), spin = "circle", color = "#E41A1C"),
      addSpinner(plotOutput("plot3"), spin = "bounce", color = "#377EB8"),
      addSpinner(plotOutput("plot5"), spin = "folding-cube", color = "#4DAF4A"),
      addSpinner(plotOutput("plot7"), spin = "rotating-plane", color = "#984EA3"),
      addSpinner(plotOutput("plot9"), spin = "cube-grid", color = "#FF7F00")
    ),
    column(
      width = 5,
      addSpinner(plotOutput("plot2"), spin = "fading-circle", color = "#FFFF33"),
      addSpinner(plotOutput("plot4"), spin = "double-bounce", color = "#A65628"),
      addSpinner(plotOutput("plot6"), spin = "dots", color = "#F781BF"),
      addSpinner(plotOutput("plot8"), spin = "cube", color = "#999999")
    )
  ),
  actionButton(inputId = "refresh2", label = "Refresh", width = "100%")
)

server <- function(input, output, session) {

  dat <- reactive({
    input$refresh
    input$refresh2
    Sys.sleep(3)
    Sys.time()
  })

  lapply(
    X = seq_len(9),
    FUN = function(i) {
      output[[paste0("plot", i)]] <- renderPlot({
        dat()
        plot(sin, -pi, i*pi)
      })
    }
  )

}

shinyApp(ui, server)

# ------------------------------------------------------------------------ #
#
# Descriptif : Checkbox Group Buttons : fonctions R
#     Detail : http://getbootstrap.com/javascript/#buttons-checkbox-radio
#
#
# Auteur : Victor PERRIER
#
# Date creation : 01/07/2016
# Date modification : 01/07/2016
#
# Version 1.0
#
# ------------------------------------------------------------------------ #


# checkboxGroupButtons ----------------------------------------------------

library("shiny")
library("shinyWidgets")

function(input, output, session) {


  lapply(
    X = seq_len(14),
    FUN = function(x) {
      output[[paste0("res", x)]] <- renderPrint({
        input[[paste0("test", x)]]
      })
    }
  )

  observeEvent(input$maj, {
    if (input$maj != "Aucun") {
      updateCheckboxGroupButtons(session = session, inputId = "test10", selected = input$maj)
    }
  })

  output$resverif <- renderPrint({
    input$verif
  })

  output$verifDT <- renderDataTable({
    head(iris)
  })

}

#  ------------------------------------------------------------------------
#
# Title : colorPicker with noUiSlider
#    By : VP
#  Date : 2018-02-22
#
#  ------------------------------------------------------------------------




# app ---------------------------------------------------------------------


ui <- fluidPage(
  tags$h3("color picker !"),
  tags$br(),

  fluidRow(
    column(
      width = 6,
      noUiSliderInput(
        inputId = "red", min = 0, max = 255,
        value = 127, tooltips = FALSE,
        step = 1, orientation = "vertical",
        color = "#c0392b", inline = TRUE,
        height = "200px", width = "30px"
      ),
      noUiSliderInput(
        inputId = "green", min = 0, max = 255,
        value = 127, tooltips = FALSE,
        step = 1, orientation = "vertical",
        color = "#27ae60", inline = TRUE,
        height = "200px", width = "30px"
      ),
      noUiSliderInput(
        inputId = "blue", min = 0, max = 255,
        value = 127, tooltips = FALSE,
        step = 1, orientation = "vertical",
        color = "#2980b9", inline = TRUE,
        height = "200px", width = "30px"
      ),
      uiOutput(
        outputId = "color",
        style = "display: inline-block; margin: 60px 26px;"
      )
    ),
    column(
      width = 6,
      noUiSliderInput(
        inputId = "redb", min = 0, max = 255,
        value = 127, tooltips = FALSE,
        step = 1, orientation = "vertical",
        direction = "rtl",
        color = "#c0392b", inline = TRUE,
        height = "200px", width = "30px"
      ),
      noUiSliderInput(
        inputId = "greenb", min = 0, max = 255,
        value = 127, tooltips = FALSE,
        step = 1, orientation = "vertical",
        direction = "rtl",
        color = "#27ae60", inline = TRUE,
        height = "200px", width = "30px"
      ),
      noUiSliderInput(
        inputId = "blueb", min = 0, max = 255,
        value = 127, tooltips = FALSE,
        step = 1, orientation = "vertical",
        direction = "rtl",
        color = "#2980b9", inline = TRUE,
        height = "200px", width = "30px"
      ),
      uiOutput(
        outputId = "colorb",
        style = "display: inline-block; margin: 60px 26px;"
      )
    )
  )

)

server <- function(input, output, session) {

  output$color <- renderUI({
    tags$div(
      style = "height: 100px; width: 100px;",
      style = "border: 1px solid #fff; box-shadow: 0 0 10px;",
      style = paste0("background: ", rgb(input$red/255, input$green/255, input$blue/255), ";")
    )
  })

  output$colorb <- renderUI({
    tags$div(
      style = "height: 100px; width: 100px;",
      style = "border: 1px solid #fff; box-shadow: 0 0 10px;",
      style = paste0("background: ", rgb(input$redb/255, input$greenb/255, input$blueb/255), ";")
    )
  })

}

shinyApp(ui, server)

library(shiny)
library(shinyWidgets)
library(htmltools)

state_data <- data.frame(
  name = state.name,
  abb = state.abb,
  region = state.region,
  division = state.division
)

ui <- fluidPage(
  tags$h2("Slim Select examples"),
  fluidRow(
    column(
      width = 4,

      slimSelectInput(
        inputId = "slim1",
        label = "Single slim select:",
        choices = month.name,
        width = "100%"
      ),
      verbatimTextOutput("res1"),

      slimSelectInput(
        inputId = "slim4",
        label = "Allow deselect in single select:",
        choices = month.name,
        placeholder = "Select something:",
        allowDeselect = TRUE,
        width = "100%"
      ),
      verbatimTextOutput("res4")

    ),
    column(
      width = 4,

      slimSelectInput(
        inputId = "slim2",
        label = "Multiple slim select:",
        choices = month.name,
        multiple = TRUE,
        placeholder = "Select a month",
        width = "100%"
      ),
      verbatimTextOutput("res2"),

      slimSelectInput(
        inputId = "slim5",
        label = "Keep order:",
        choices = month.name,
        multiple = TRUE,
        keepOrder = TRUE,
        width = "100%"
      ),
      verbatimTextOutput("res5")

    ),
    column(
      width = 4,

      htmltools::tagAppendAttributes(slimSelectInput(
        inputId = "slim6",
        label = "Always open:",
        choices = month.name,
        multiple = TRUE,
        alwaysOpen = TRUE,
        width = "100%"
      ), style = css(height = "350px")),
      verbatimTextOutput("res6"),

      slimSelectInput(
        inputId = "slim3",
        label = "Use prepare_slim_choices:",
        choices = prepare_slim_choices(
          state_data,
          label = name,
          value = abb,
          .by = region,
          selectAll = TRUE,
          closable = "close"
        ),
        multiple = TRUE,
        width = "100%"
      ),
      verbatimTextOutput("res3")

    )
  )
)

server <- function(input, output, session) {

  output$res1 <- renderPrint(input$slim1)

  output$res2 <- renderPrint(input$slim2)

  output$res3 <- renderPrint(input$slim3)

  output$res4 <- renderPrint(input$slim4)

  output$res5 <- renderPrint(input$slim5)

  output$res6 <- renderPrint(input$slim6)

}

if (interactive())
  shinyApp(ui, server)

#  ------------------------------------------------------------------------
#
# Title : shinyWidgets Gallery - server
#    By : Victor
#  Date : 2020-12-01
#
#  ------------------------------------------------------------------------



function(input, output, session) {

  # cleanup app
  session$onSessionEnded(function() {
    suppressWarnings(
      rm(.shinyWidgetGalleryFuns, .shinyWidgetGalleryId, ID, envir = globalenv())
    )
    shiny::stopApp()
  })

  # highlight code dropdowns & sweetalert
  .shinyWidgetGalleryFuns$highlightCode(session, "code_dropdownButton")

  .shinyWidgetGalleryFuns$highlightCode(session, "code_dropdown")

  .shinyWidgetGalleryFuns$highlightCode(session, "codeSA")

  # navigation ----

  observeEvent(input$toSwictchInput, {
    updateTabItems(session = session, inputId = "tabs", selected = "tabswitchInput")
  })

  observeEvent(input$toAwesome1, {
    updateTabItems(session = session, inputId = "tabs", selected = "tabAwesome")
  })
  observeEvent(input$toAwesome2, {
    updateTabItems(session = session, inputId = "tabs", selected = "tabAwesome")
  })
  observeEvent(input$toAwesome3, {
    updateTabItems(session = session, inputId = "tabs", selected = "tabAwesome")
  })

  observeEvent(input$tocheckButtons, {
    updateTabItems(session = session, inputId = "tabs", selected = "tabcheckButtons")
  })

  observeEvent(input$toMaterialSwitch, {
    updateTabItems(session = session, inputId = "tabs", selected = "tabMaterialSwitch")
  })

  observeEvent(input$toSelectPicker, {
    updateTabItems(session = session, inputId = "tabs", selected = "tabPickerInput")
  })



  # input values ----
  lapply(
    X = seq_len(.shinyWidgetGalleryId),
    FUN = function(i) {
      ii <- paste0("Id", sprintf("%03d", i))
      .shinyWidgetGalleryFuns$highlightCode(session, paste0("code", ii))
      output[[paste0("res", ii)]] <- renderPrint({
        input[[ii]]
      })
    }
  )


  # Update switchInput
  output$resswitchUp <- renderPrint({
    input$switchUp
  })
  observeEvent(input$on, {
    updateSwitchInput(session = session, inputId = "switchUp", value = TRUE)
  })
  observeEvent(input$off, {
    updateSwitchInput(session = session, inputId = "switchUp", value = FALSE)
  })


  # Update awesomeRadios
  output$resupAwesomeRadio <- renderPrint({
    input$upAwesomeRadio
  })
  observeEvent(input$upAwesomeRadioA, {
    updateAwesomeRadio(session = session, inputId = "upAwesomeRadio", selected = "A")
  })
  observeEvent(input$upAwesomeRadioB, {
    updateAwesomeRadio(session = session, inputId = "upAwesomeRadio", selected = "B")
  })
  observeEvent(input$upAwesomeRadioC, {
    updateAwesomeRadio(session = session, inputId = "upAwesomeRadio", selected = "C")
  })

  # Update awesomeRadios
  output$resupAwesomeCheckbox <- renderPrint({
    input$upAwesomeCheckbox
  })
  observeEvent(input$upAwesomeCheckbox1, {
    updateAwesomeCheckboxGroup(session = session, inputId = "upAwesomeCheckbox", choices = c("a", "b", "c"), inline = TRUE, status = "success")
  })
  observeEvent(input$upAwesomeCheckbox2, {
    updateAwesomeCheckboxGroup(session = session, inputId = "upAwesomeCheckbox", choices = c("A", "B", "C"), inline = TRUE, status = "warning")
  })


  # update checkboxGroupButtons ----
  output$resupcheckboxGroupButtons <- renderPrint({
    input$upcheckboxGroupButtons
  })
  observeEvent(input$upCheckBtnA, {
    updateCheckboxGroupButtons(session = session, inputId = "upcheckboxGroupButtons", selected = "A")
  })
  observeEvent(input$upCheckBtnB, {
    updateCheckboxGroupButtons(session = session, inputId = "upcheckboxGroupButtons", selected = "B")
  })
  observeEvent(input$upCheckBtnC, {
    updateCheckboxGroupButtons(session = session, inputId = "upcheckboxGroupButtons", selected = "C")
  })
  observeEvent(input$upCheckBtnD, {
    updateCheckboxGroupButtons(session = session, inputId = "upcheckboxGroupButtons", selected = "D")
  })


  # Update radioGroupButtons ----
  output$resupradioGroupButtons <- renderPrint({
    input$upradioGroupButtons
  })
  observeEvent(input$upRadioBtnA, {
    updateRadioGroupButtons(session = session, inputId = "upradioGroupButtons", selected = "A")
  })
  observeEvent(input$upRadioBtnB, {
    updateRadioGroupButtons(session = session, inputId = "upradioGroupButtons", selected = "B")
  })
  observeEvent(input$upRadioBtnC, {
    updateRadioGroupButtons(session = session, inputId = "upradioGroupButtons", selected = "C")
  })
  observeEvent(input$upRadioBtnD, {
    updateRadioGroupButtons(session = session, inputId = "upradioGroupButtons", selected = "D")
  })





  # Update materialSwitch ----
  output$resupMaterial <- renderPrint({
    input$upMaterial
  })
  observeEvent(input$upMaterialY, {
    updateMaterialSwitch(session = session, inputId = "upMaterial", value = TRUE)
  })
  observeEvent(input$upMaterialN, {
    updateMaterialSwitch(session = session, inputId = "upMaterial", value = FALSE)
  })






  # Update PickerInput ----
  output$resuppickerIcons <- renderPrint({
    input$uppickerIcons
  })
  observeEvent(input$uppickerIconsRadio, {
    if (input$uppickerIconsRadio == "Glyphicon") {
      updatePickerInput(
        session = session, inputId = "uppickerIcons", selected = input$uppickerIcons,
        choices = c("glyphicon-arrow-right / fa-arrow-right", "glyphicon-cog / fa-cog", "glyphicon-play / fa-play",
                    "glyphicon-ok-sign / fa-check", "glyphicon-euro / fa-eur", "glyphicon-music / fa-music"),
        choicesOpt = list(
          icon = c("glyphicon glyphicon-arrow-right", "glyphicon glyphicon-cog", "glyphicon glyphicon-play",
                   "glyphicon glyphicon-ok-sign", "glyphicon glyphicon-euro", "glyphicon glyphicon-music")
        )
      )
    } else {
      updatePickerInput(
        session = session, inputId = "uppickerIcons", selected = input$uppickerIcons,
        choices = c("glyphicon-arrow-right / fa-arrow-right", "glyphicon-cog / fa-gear", "glyphicon-play / fa-play",
                    "glyphicon-ok-sign / fa-check", "glyphicon-euro / fa-eur", "glyphicon-music / fa-music"),
        choicesOpt = list(
          icon = c("fa fa-arrow-right", "fa fa-gear", "fa fa-play",
                   "fa fa-check", "fa fa-eur", "fa fa-music")
        )
      )
    }
  })



  # Update sliderText ----

  output$resselectedSliderText <- renderPrint({
    input$selectedSliderText
  })
  observeEvent(input$upSelectedSliderText, {
    updateSliderTextInput(
      session = session,
      inputId = "selectedSliderText",
      selected = input$upSelectedSliderText
    )
  }, ignoreInit = TRUE)

  output$reschoicesSliderText <- renderPrint({
    input$choicesSliderText
  })
  observeEvent(input$upChoicesSliderText, {
    choices <- switch(
      input$upChoicesSliderText,
      "Abbreviations" = month.abb,
      "Full names" = month.name
    )
    updateSliderTextInput(
      session = session,
      inputId = "choicesSliderText",
      choices = choices
    )
  }, ignoreInit = TRUE)




  # dropdown : iris clustering example ----
  selectedData <- reactive({
    iris[, c(input$xcol, input$ycol)]
  })

  clusters <- reactive({
    kmeans(selectedData(), input$clusters)
  })

  output$plot1 <- renderPlot({
    palette(c("#E41A1C", "#377EB8", "#4DAF4A", "#984EA3",
              "#FF7F00", "#FFFF33", "#A65628", "#F781BF", "#999999"))

    par(mar = c(5.1, 4.1, 0, 1))
    plot(selectedData(),
         col = clusters()$cluster,
         pch = 20, cex = 3)
    points(clusters()$centers, pch = 4, cex = 4, lwd = 4)
  })


  # dropdown 2 : iris clustering example ----
  selectedData2 <- reactive({
    iris[, c(input$xcol2, input$ycol2)]
  })

  clusters2 <- reactive({
    kmeans(selectedData2(), input$clusters2)
  })

  output$plot2 <- renderPlot({
    palette(c("#E41A1C", "#377EB8", "#4DAF4A", "#984EA3",
              "#FF7F00", "#FFFF33", "#A65628", "#F781BF", "#999999"))

    par(mar = c(5.1, 4.1, 0, 1))
    plot(selectedData2(),
         col = clusters2()$cluster,
         pch = 20, cex = 3)
    points(clusters2()$centers, pch = 4, cex = 4, lwd = 4)
  })



  # sweetalert ----
  observeEvent(input$success, {
    sendSweetAlert(
      session = session, title = "Success !!", text = "All in order", type = "success"
    )
  })

  observeEvent(input$error, {
    sendSweetAlert(
      session = session, title = "Error...", text = "Oups !", type = "error"
    )
  })

  observeEvent(input$info, {
    sendSweetAlert(
      session = session, title = "Information", text = "Something helpful", type = "info"
    )
  })

  # observeEvent(input$tags, {
  #   sendSweetAlert(
  #     session = session, title = "HTLM tags",
  #     text = "normal <b>bold</b> <span style='color: steelblue;'>color</span> <h1>h1</h1>", html = TRUE, type = NULL
  #   )
  # })

  observeEvent(input$warning, {
    sendSweetAlert(
      session = session, title = "Warning !!!",
      text = NULL, type = "warning"
    )
  })


  observeEvent(input$launch_confirmation, {
    confirmSweetAlert(
      session = session, inputId = "myconfirmation", type = "warning",
      title = "Want to confirm ?", danger_mode = TRUE
    )
  })
  output$res_confirmation <- renderPrint(input$myconfirmation)

  # Progress Bars ----

  lapply(
    X = paste0("pb", 1:10),
    FUN = function(i) {
      .shinyWidgetGalleryFuns$highlightCode(session, paste0("code", i))
    }
  )

  observeEvent(input$uppb1, {
    updateProgressBar(session = session, id = "pb1", value = input$uppb1)
  })

  observeEvent(input$uppb2, {
    updateProgressBar(session = session, id = "pb2", value = input$uppb2)
  })

  observeEvent(input$uppb3, {
    updateProgressBar(session = session, id = "pb3", value = input$uppb3)
  })

  observeEvent(input$uppb4, {
    updateProgressBar(session = session, id = "pb4", value = input$uppb4)
  })

  observeEvent(input$uppb5, {
    updateProgressBar(session = session, id = "pb5", value = input$uppb5, total = 5000)
  })

  observeEvent(input$uppb6, {
    updateProgressBar(session = session, id = "pb6", value = input$uppb6)
  })

  observeEvent(input$uppb7, {
    if (input$uppb7 < 33) {
      status <- "danger"
    } else if (input$uppb7 >= 33 & input$uppb7 < 67) {
      status <- "warning"
    } else {
      status <- "success"
    }
    updateProgressBar(session = session, id = "pb7", value = input$uppb7, status = status)
  })

  observeEvent(input$uppb8, {
    updateProgressBar(session = session, id = "pb8", value = input$uppb8, total = 5000)
  })

  observeEvent(input$uppb9, {
    updateProgressBar(session = session, id = "pb9", value = 1000, total = input$uppb9)
  })


}

library("shiny")
library("shinyWidgets")

ui <- fluidPage(
  tags$h1("Exemple dropdown"),

  dropdown(
    tags$h3("List of Input"),
    shinyWidgets::pickerInput(inputId = 'xcol', label = 'X Variable', choices = names(iris)),
    selectInput(inputId = 'ycol', label = 'Y Variable', choices = names(iris), selected = names(iris)[[2]]),
    sliderInput(inputId = 'clusters', label = 'Cluster count', value = 3, min = 1, max = 9),
    style = "material-circle", icon = icon("gear"), status = "danger",
    animate = animateOptions(enter = animations$zooming_entrances$zoomInDown, exit = animations$zooming_exits$zoomOutUp, duration = 1)
  ),
  plotOutput(outputId = 'plot1')

)

server <- function(input, output, session) {
  selectedData <- reactive({
    iris[, c(input$xcol, input$ycol)]
  })
  clusters <- reactive({
    kmeans(selectedData(), input$clusters)
  })
  output$plot1 <- renderPlot({
    palette(c("#E41A1C", "#377EB8", "#4DAF4A", "#984EA3",
              "#FF7F00", "#FFFF33", "#A65628", "#F781BF", "#999999"))
    par(mar = c(5.1, 4.1, 0, 1))
    plot(selectedData(),
         col = clusters()$cluster,
         pch = 20, cex = 3)
    points(clusters()$centers, pch = 4, cex = 4, lwd = 4)
  })
}

shinyApp(ui = ui, server = server)

# ui : call this function once somewhere
useSweetAlert()


# server : launch a sweet alert anytime you want
# here they are launched when actionButtons are clicked
# but it can be after loading data, a successful (or not)
# long calculation, ...

observeEvent(input$success, {
  sendSweetAlert(
    session = session,
    title = "Success !!",
    text = "All in order",
    type = "success"
  )
})

observeEvent(input$error, {
  sendSweetAlert(
    session = session,
    title = "Error...",
    text = "Oups !",
    type = "error"
  )
})

observeEvent(input$info, {
  sendSweetAlert(
    session = session,
    title = "Information",
    text = "Something helpful",
    type = "info"
  )
})

observeEvent(input$tags, {
  sendSweetAlert(
    session = session,
    title = "HTLM tags",
    text = "normal <b>bold</b> <span style='color: steelblue;'>color</span> <h1>h1</h1>",
    html = TRUE,
    type = NULL
  )
})

observeEvent(input$warning, {
  sendSweetAlert(
    session = session,
    title = "Warning !!!",
    text = NULL,
    type = "warning"
  )
})

# Uglify shinyWidgets files -----------------------------------------------

# js ----

# not used
# js_files <- list.files(path = "inst/www/", pattern = "\\.js$", full.names = TRUE, recursive = TRUE)
# js_files <- lapply(js_files, readLines)
# js_files <- lapply(js_files, paste, collapse = "\n")
# js_files <- paste(unlist(js_files), collapse = "\n")
# library("js")
# js_files <- uglify_optimize(text = js_files)
# writeLines(text = js_files, con = "inst/www/shinyWidgets.min.js")



# bindings ----

# create one file with all bindings
bindings_files <- list.files(path = "inst/assets/", pattern = "bindings", full.names = TRUE, recursive = TRUE)
bindings_files <- bindings_files[bindings_files != "inst/assets/shinyWidgets-bindings.min.js"]
bindings_files <- bindings_files[bindings_files != "inst/assets/sweetAlert/sweetalert-bindings.js"]
bindings_files <- bindings_files[bindings_files != "inst/assets/air-datepicker/datepicker-bindings.js"]
bindings_files <- bindings_files[!grepl(pattern = "awesome", bindings_files)]
bindings_files <- lapply(bindings_files, readLines)
bindings_files <- lapply(bindings_files, paste, collapse = "\n")
bindings_files <- paste(unlist(bindings_files), collapse = "\n")

library("js")
bindings_files <- uglify_optimize(text = bindings_files)

writeLines(text = bindings_files, con = "inst/assets/shinyWidgets-bindings.min.js")



# css ----

# all files
css_files <- list.files(path = "inst/assets/", pattern = "\\.css$", full.names = TRUE, recursive = TRUE)

# keep the ones not integrated via a widgets
css_files <- css_files[
  grepl(pattern = "checkboxGroupButtons", x = css_files, fixed = TRUE) |
    grepl(pattern = "radioGroupButtons", x = css_files) |
    grepl(pattern = "circle-button", x = css_files) |
    grepl(pattern = "material-switch", x = css_files, fixed = TRUE) |
    # grepl(pattern = "multi-shiny", x = css_files) |
    grepl(pattern = "sw-color-selector", x = css_files)
  ]

# read them all
css_files <- lapply(css_files, readLines)
# concat in one string
css_files <- lapply(css_files, paste, collapse = "\n")
css_files <- paste(unlist(css_files), collapse = "\n")

# write them all
writeLines(text = css_files, con = "inst/assets/shinyWidgets.css")

# go here to minify the file
# https://cssminifier.com/

.shinyWidgetGalleryFuns$tabPretty <- function() {
  tagList(
    tags$h1("Pretty Checkboxes And Radios", class = "fw-bold text-primary"),
    tags$h5(
      "via ",
      tags$a(href = "https://lokesh-coder.github.io/pretty-checkbox/", "pretty checkbox")
    ),
    br(),

    fluidRow(

      column(
        width = 4,

        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Default single checkbox",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyCheckbox,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Click me!", value = TRUE)
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "With status",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyCheckbox,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Click me!", value = TRUE,
                        status = "warning")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "With curve shape",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyCheckbox,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Click me!", value = TRUE,
                        status = "danger", shape = "curve")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "With outline color",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyCheckbox,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Click me!", value = TRUE,
                        status = "danger", shape = "curve", outline = TRUE)
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "With fill color",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyCheckbox,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Click me!", value = TRUE,
                        status = "success", fill = TRUE)
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "With Font Awesome icon",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyCheckbox,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Click me!", value = TRUE,
                        status = "info", icon = icon("thumbs-up"), plain = TRUE, outline = TRUE)
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "With animation",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyCheckbox,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Click me!", value = TRUE,
                        icon = icon("check"), status = "success", animation = "rotate")
          )
        )

      ),

      column(
        width = 4,

        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Default switch",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettySwitch,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Click me!")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Switch fill & status",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettySwitch,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Click me!", status = "success", fill = TRUE)
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Switch slim & status",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettySwitch,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Click me!", status = "primary", slim = TRUE)
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Default toggle",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyToggle,
            args = list(inputId = ID(.shinyWidgetGalleryId), label_on = "Checked!",
                        label_off = "Unchecked...")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Toggle with icons & status",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyToggle,
            args = list(inputId = ID(.shinyWidgetGalleryId),
                        label_on = "Yes!", icon_on = icon("check"),
                        status_on = "info", status_off = "warning",
                        label_off = "No..", icon_off = icon("xmark"))
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Toggle with icons",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyToggle,
            args = list(inputId = ID(.shinyWidgetGalleryId), label_on = "Yes!",
                        label_off = "No..", outline = TRUE,
                        plain = TRUE,
                        icon_on = icon("thumbs-up"),
                        icon_off = icon("thumbs-down"))
          )
        )

      ),

      column(
        width = 4,

        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Default checkbox group",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyCheckboxGroup,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Choose:", choices = c("Click me !", "Me !", "Or me !"))
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Inline checkbox group & fill status",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyCheckboxGroup,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Choose:", choices = c("Click me !", "Me !", "Or me !"),
                        inline = TRUE, status = "danger", fill = TRUE)
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Checkbox group with icons",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyCheckboxGroup,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Choose:", choices = c("Click me !", "Me !", "Or me !"),
                        icon = icon("user"), animation = "tada")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Checkbox group with icons, status & outline",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyCheckboxGroup,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Choose:", choices = c("Click me !", "Me !", "Or me !"),
                        icon = icon("square-check"), status = "primary", outline = TRUE, animation = "jelly")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Default radio buttons",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyRadioButtons,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Choose:", choices = c("Click me !", "Me !", "Or me !"))
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Inline radio buttons & fill status",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyRadioButtons,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Choose:", choices = c("Click me !", "Me !", "Or me !"),
                        inline = TRUE, status = "danger", fill = TRUE)
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Radio buttons with icons",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyRadioButtons,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Choose:", choices = c("Click me !", "Me !", "Or me !"),
                        icon = icon("user"), animation = "tada")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Radio buttons with icons, status",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = prettyRadioButtons,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "Choose:", choices = c("Click me !", "Me !", "Or me !"),
                        icon = icon("check"), bigger = TRUE,
                        status = "info", animation = "jelly")
          )
        )

      )

    )
  )
}

library(shiny)
library(shinyWidgets)

ui <- fluidPage(
  html_dependency_winbox(),
  actionButton(inputId = "show", label = "Show WinBox as modal")
)

server <- function(input, output, session) {


  observeEvent(input$show, {
    WinBox(
      title = "WinBox as modal",
      ui = tagList(
        tags$h2("Hello from WinBox!"),
        "Text content of winbox.",
        actionButton("show2", "Open a normal winbox")
      ),
      options = wbOptions(modal = TRUE)
    )
  })

  observeEvent(input$show2, {
    WinBox(
      title = "Normal WinBox",
      ui = tagList(
        tags$h2("Hello from WinBox!"),
        "Text content of winbox."
      ),
      options = wbOptions(background = "firebrick")
    )
  })

}

if (interactive())
  shinyApp(ui, server)

.shinyWidgetGalleryFuns$tabVirtualSelect <- function() {
  tagList(
    tags$h1("Virtual Select", class = "fw-bold text-primary"),
    tags$h5(
      "via ",
      tags$a(href = "https://github.com/sa-si-dev/virtual-select", "virtual-select")
    ),
    br(),

    fluidRow(
      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Default",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = virtualSelectInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Default :",
              choices = month.name,
              width = "100%",
              dropboxWrapper = "body"
            )
          )
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Multiple",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = virtualSelectInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Multiple :",
              choices = month.name,
              multiple = TRUE,
              width = "100%",
              dropboxWrapper = "body"
            )
          )
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Group choices",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = virtualSelectInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Group choices :",
              choices = list(
                Winter = month.name[1:3],
                Spring = month.name[4:6],
                Summer = month.name[7:9],
                Fall = month.name[10:12]
              ),
              multiple = TRUE,
              width = "100%",
              dropboxWrapper = "body"
            )
          )
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "HTML in choices",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = virtualSelectInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "HTML in choices :",
              choices = setNames(
                as.list(month.abb),
                mapply(
                  FUN = function(number, month, color) {
                    as.character(tagList(
                      icon("calendar-days"),
                      tags$b(
                        style = css(color = color),
                        month
                      )
                    ))
                  },
                  month = month.name,
                  color = palette.colors(n = 12, palette = "Alphabet")
                )
              ),
              html = TRUE,
              width = "100%",
              dropboxWrapper = "body"
            )
          )
        )
      ),

      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Search",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = virtualSelectInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Search :",
              choices = month.name,
              search = TRUE,
              markSearchResults = TRUE,
              width = "100%",
              dropboxWrapper = "body"
            )
          )
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Show values as tags",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = virtualSelectInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Show values as tags :",
              choices = month.name,
              multiple = TRUE,
              showValueAsTags = TRUE,
              width = "100%",
              dropboxWrapper = "body"
            )
          )
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Allow new option",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = virtualSelectInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Allow new option :",
              choices = month.name,
              allowNewOption = TRUE,
              width = "100%",
              dropboxWrapper = "body"
            )
          )
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Always open",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = virtualSelectInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Always open :",
              choices = month.name,
              keepAlwaysOpen = TRUE,
              width = "100%",
              dropboxWrapper = "body"
            )
          )
        )
      ),

      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Add a description",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = virtualSelectInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Add a description:",
              choices = prepare_choices(
                data.frame(
                  name = state.name,
                  abb = state.abb,
                  region = state.region,
                  division = state.division
                ),
                label = name,
                value = abb,
                description = division
              ),
              multiple = TRUE,
              hasOptionDescription = TRUE,
              width = "100%",
              dropboxWrapper = "body"
            )
          )
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Disable group select all",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = virtualSelectInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Disable group select all:",
              choices = list(
                Winter = month.name[1:3],
                Spring = month.name[4:6],
                Summer = month.name[7:9],
                Fall = month.name[10:12]
              ),
              multiple = TRUE,
              disableOptionGroupCheckbox = TRUE,
              width = "100%",
              dropboxWrapper = "body"
            )
          )
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Show as popup",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = virtualSelectInput,
            args = list(
              inputId = ID(.shinyWidgetGalleryId),
              label = "Show as popup :",
              choices = month.name,
              showDropboxAsPopup = TRUE,
              popupDropboxBreakpoint = "3000px",
              width = "100%",
              dropboxWrapper = "body"
            )
          )
        )
      )
    )
  )
}

# timepicker examples --------------------------------------------------

library(shiny)
library(shinyWidgets)




# ui ----

ui <- fluidPage(
  tags$h2("Update airDatepickerInput"),
  tags$br(),

  fluidRow(

    column(
      width = 6,

      airDatepickerInput(
        inputId = "airup1",
        label = "Update by selecting a date below:"
      ),
      verbatimTextOutput(outputId = "res_airup1"),
      sliderInput(
        inputId = "update_airup1",
        label = "Choose a date to update air datepicker:",
        min = Sys.Date() - 7, value = Sys.Date(), max = Sys.Date() + 7
      ),

      tags$br(),

      airDatepickerInput(
        inputId = "airuplabel",
        label = "Update label:"
      ),
      verbatimTextOutput(outputId = "res_airuplabel"),
      textInput(
        inputId = "updatelabel",
        label = "Update label above"
      )

    ),

    column(
      width = 6,

      airDatepickerInput(
        inputId = "airclear",
        label = "Clear all dates selected:",
        multiple = TRUE,
        value = Sys.Date() + 1:7
      ),
      verbatimTextOutput(outputId = "res_airclear"),
      actionButton(
        inputId = "upclear", label = "Clear dates"
      )

    )

  )
)

# server ----

server <- function(input, output, session) {

  # Update selected date
  output$res_airup1 <- renderPrint( str(input$airup1) )
  observeEvent(input$update_airup1, {
    updateAirDateInput(
      session = session,
      inputId = "airup1",
      value = input$update_airup1
    )
  })

  # Clear all dates selected
  output$res_airclear <- renderPrint( str(input$airclear) )
  observeEvent(input$upclear, {
    updateAirDateInput(
      session = session,
      inputId = "airclear",
      clear = TRUE
    )
  })

  observeEvent(input$updatelabel, {
    updateAirDateInput(
      session = session,
      inputId = "airuplabel",
      label = input$updatelabel
    )
  }, ignoreInit = TRUE)

}

# app ----

shinyApp(ui = ui, server = server)

#  ------------------------------------------------------------------------
#
# Title : noUiSlider in Shiny
#    By : VP
#  Date : 2018-02-22
#
#  ------------------------------------------------------------------------



# app ---------------------------------------------------------------------


ui <- fluidPage(
  tags$h3("Update method"),
  tags$br(),

  fluidRow(

    column(
      width = 6,
      panel(
        status = "danger", heading = "Update single slider",
        noUiSliderInput(
          inputId = "to_update",
          label = "Slider update:",
          min = 0, max = 1000,
          value = 50, step = 50,
          color = "#F2DEDE"
        ),
        verbatimTextOutput(outputId = "res_updated"),
        sliderInput(
          inputId = "update",
          label = "Update value",
          min = 0, max = 1000,
          step = 50, value = 50
        )
      ),

      panel(
        status = "danger", heading = "Update range slider",
        noUiSliderInput(
          inputId = "to_update_range",
          label = "Slider update:",
          min = 0, max = 1000,
          value = c(50, 200), step = 50,
          color = "#F2DEDE"
        ),
        verbatimTextOutput(outputId = "res_updated_range"),
        sliderInput(
          inputId = "update_range",
          label = "Update value",
          min = 0, max = 1000,
          step = 50, value = c(50, 200)
        )
      )

    ),

    column(
      width = 6,

      panel(
        status = "danger", heading = "Update min/max",
        noUiSliderInput(
          inputId = "to_update_minmax",
          label = "Slider disable:",
          min = 0, max = 100, value = 50,
          color = "#F2DEDE"
        ),
        verbatimTextOutput(outputId = "res_update_minmax"),
        actionButton(inputId = "minmax_0_100", label = "Set min=0 & max=100"),
        actionButton(inputId = "minmax_1000_5000", label = "Set min=1000 & max=5000")
      ),

      panel(
        status = "danger", heading = "Disable",
        noUiSliderInput(
          inputId = "to_disable",
          label = "Slider disable:",
          min = 0, max = 1000, value = 500,
          color = "#F2DEDE"
        ),
        verbatimTextOutput(outputId = "res_disabled"),
        checkboxInput(
          inputId = "disable",
          label = "Disable slider",
          value = FALSE
        )
      ),

      panel(
        status = "danger", heading = "Disable specific handler",
        noUiSliderInput(
          inputId = "disable_handler",
          label = "Disable specific handler:",
          min = 0,
          max = 1000,
          value = c(50, 200),
          color = "#F2DEDE",
          behaviour = "drag"
        ),
        verbatimTextOutput(outputId = "res_disable_handler"),
        checkboxInput(
          inputId = "disable_1",
          label = "Disable handler 1",
          value = FALSE
        ),
        checkboxInput(
          inputId = "disable_2",
          label = "Disable handler 2",
          value = FALSE
        )
      )
    )

  )

)

server <- function(input, output, session) {

  output$res_updated <- renderPrint(input$to_update)
  observeEvent(input$update, {
    updateNoUiSliderInput(session, "to_update", value = input$update)
  }, ignoreInit = TRUE)

  output$res_updated_range <- renderPrint(input$to_update_range)
  observeEvent(input$update_range, {
    updateNoUiSliderInput(session, "to_update_range", value = input$update_range)
  }, ignoreInit = TRUE)


  output$res_update_minmax <- renderPrint(input$to_update_minmax)
  observeEvent(input$minmax_0_100, {
    updateNoUiSliderInput(
      session = session,
      inputId = "to_update_minmax",
      range = c(0, 100)
    )
  })
  observeEvent(input$minmax_1000_5000, {
    updateNoUiSliderInput(
      session = session,
      inputId = "to_update_minmax",
      range = c(1000, 5000)
    )
  })

  # Disable
  output$res_disabled <- renderPrint(input$to_disable)
  observeEvent(input$disable, {
    updateNoUiSliderInput(
      session = session,
      inputId = "to_disable",
      disable = input$disable
    )
  })

  # Disable specific handlers
  output$res_disable_handler <- renderPrint(input$disable_handler)
  observeEvent(input$disable_1, {
    if (input$disable_1) {
      updateNoUiSliderInput(
        session = session,
        inputId = "disable_handler",
        disableHandlers = 1
      )
    } else {
      updateNoUiSliderInput(
        session = session,
        inputId = "disable_handler",
        enableHandlers = 1
      )
    }
  })
  observeEvent(input$disable_2, {
    if (input$disable_2) {
      updateNoUiSliderInput(
        session = session,
        inputId = "disable_handler",
        disableHandlers = 2
      )
    } else {
      updateNoUiSliderInput(
        session = session,
        inputId = "disable_handler",
        enableHandlers = 2
      )
    }
  })

}

shinyApp(ui, server)

.shinyWidgetGalleryFuns$tabBttn <- function() {
  tagList(
    tags$h1("bttn", class = "fw-bold text-primary"),

    fluidRow(

      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = NULL,
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = actionBttn,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = NULL, style = "material-circle", color = "danger", icon = icon("bars"))
          ),
          footer = NULL
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = NULL,
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = actionBttn,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "material-flat", style = "material-flat", color = "danger")
          ),
          footer = NULL
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = NULL,
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = actionBttn,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "pill", style = "pill", color = "danger")
          ),
          footer = NULL
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = NULL,
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = actionBttn,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "float", style = "float", color = "danger")
          ),
          footer = NULL
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = NULL,
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = actionBttn,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "unite", style = "unite", color = "danger")
          ),
          footer = NULL
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = NULL,
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = actionBttn,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "fill", style = "fill", color = "danger")
          ),
          footer = NULL
        )
      ),



      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = NULL,
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = actionBttn,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = NULL, style = "simple", color = "primary", icon = icon("bars"))
          ),
          footer = NULL
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = NULL,
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = actionBttn,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "bordered", style = "bordered", color = "success", icon = icon("sliders"))
          ),
          footer = NULL
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = NULL,
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = actionBttn,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "minimal", style = "minimal", color = "danger")
          ),
          footer = NULL
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = NULL,
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = actionBttn,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "stretch", style = "stretch", color = "warning")
          ),
          footer = NULL
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = NULL,
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = actionBttn,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "jelly", style = "jelly", color = "danger")
          ),
          footer = NULL
        ),
        .shinyWidgetGalleryFuns$box_wrapper(
          title = NULL,
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = actionBttn,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "gradient", style = "gradient", color = "danger", icon = icon("thumbs-up"))
          ),
          footer = NULL
        )
      )
    )
  )
}

library("shiny")
library("shinyWidgets")

choices_colors <- colors(distinct = TRUE)
choices_colors <- choices_colors[!grepl(pattern = "\\d$", x = choices_colors)]


ui <- fluidPage(

  colorSelectorDrop(
    inputId = "mycolor1",
    label = NULL, circle = FALSE, size = "default",
    choices = choices_colors
  ),
  verbatimTextOutput("result1"),

  colorSelectorDrop(
    inputId = "mycolor2",
    label = NULL, circle = FALSE, size = "sm",
    choices = choices_colors
  ),
  verbatimTextOutput("result2"),

  colorSelectorDrop(
    inputId = "mycolor3",
    label = NULL, circle = FALSE, size = "xs",
    choices = choices_colors
  ),
  verbatimTextOutput("result3"),

  colorSelectorDrop(
    inputId = "mycolor4",
    label = NULL,
    choices = choices_colors
  ),
  verbatimTextOutput("result4"),

  colorSelectorDrop(
    inputId = "mycolor5",
    label = NULL, circle = FALSE, size = "lg",
    choices = choices_colors
  ),
  verbatimTextOutput("result5")

)

server <- function(input, output, session) {
  output$result1 <- renderPrint({
    input$mycolor1
  })
  output$result2 <- renderPrint({
    input$mycolor2
  })
  output$result3 <- renderPrint({
    input$mycolor3
  })
  output$result4 <- renderPrint({
    input$mycolor4
  })
}

shinyApp(ui = ui, server = server)

# airMonthpicker examples --------------------------------------------------

library(shiny)
library(shinyWidgets)



# ui ----

ui <- fluidPage(
  tags$h2("Air monthpicker examples"),
  tags$br(),

  fluidRow(

    column(
      width = 6,

      airMonthpickerInput(
        inputId = "default",
        label = "First example:"
      ),
      verbatimTextOutput(outputId = "res_default"),

      airMonthpickerInput(
        inputId = "multiple",
        label = "Select multiple months:",
        placeholder = "You can pick 3 months",
        multiple = 3, clearButton = TRUE
      ),
      verbatimTextOutput(outputId = "res_multiple"),

      airMonthpickerInput(
        inputId = "range",
        label = "Select range of months:",
        range = TRUE, value = c(Sys.Date()-60, Sys.Date())
      ),
      verbatimTextOutput(outputId = "res_range"),

      airMonthpickerInput(
        inputId = "french",
        label = "In french:",
        language = "fr",
        dateFormat = "M yy",
        addon = "left"
      ),
      verbatimTextOutput(outputId = "res_french")

    ),

    column(
      width = 6,

      airMonthpickerInput(
        inputId = "defaultValue",
        label = "With a default month:",
        value = Sys.Date()
      ),
      verbatimTextOutput(outputId = "res_defaultValue"),

      airMonthpickerInput(
        inputId = "minmax",
        label = "Min & max month (only 2018):",
        minDate = "2018-01-01", maxDate = "2018-12-01"
      ),
      verbatimTextOutput(outputId = "res_minmax"),

      airMonthpickerInput(
        inputId = "inline",
        label = "Inline:",
        inline = TRUE
      ),
      verbatimTextOutput(outputId = "res_inline")

    )

  )
)

# server ----

server <- function(input, output, session) {

  output$res_default <- renderPrint( str(input$default) )
  output$res_defaultValue <- renderPrint( str(input$defaultValue) )
  output$res_multiple <- renderPrint( str(input$multiple) )
  output$res_range <- renderPrint( str(input$range) )
  output$res_minmax <- renderPrint({ str(input$minmax) })
  output$res_inline <- renderPrint({ str(input$inline) })
  output$res_french <- renderPrint({ str(input$french) })
}

# app ----

shinyApp(ui = ui, server = server)

library(shiny)
library(shinyWidgets)

ui <- fluidPage(
  html_dependency_winbox()
)

server <- function(input, output, session) {

  WinBox(
    title = "WinBox",
    ui = tagList(
      tags$h3("Hello from WinBox!")
    )
  )

}

if (interactive())
  shinyApp(ui, server)

library(shiny)
library(shinyWidgets)
library(bslib)

# Custom rules to match virtual select CSS classes to Boostrap classes
vs_rules <- c(
  ".vscomp-toggle-button { @extend .btn }",
  ".vscomp-toggle-button { @extend .btn-outline-secondary }",
  ".vscomp-toggle-button { @extend .text-start }",
  ".vscomp-arrow::after { @extend .border-dark }",
  ".vscomp-arrow::after { @extend .border-start-0 }",
  ".vscomp-arrow::after { @extend .border-top-0 }",
  ".vscomp-option:hover { @extend .bg-primary }",
  ".vscomp-option  { @extend .bg-light }",
  ".vscomp-search-wrapper { @extend .bg-light }",
  ".vscomp-toggle-all-label { @extend .bg-light }"
)

# Light theme
light <- bs_add_rules(
  bs_theme(preset = "bootstrap"),
  vs_rules
)

# Dark theme
dark <- bs_add_rules(
  bs_theme(preset = "bootstrap", bg = "black", fg = "white"),
  vs_rules
)

ui <- fluidPage(
  theme = light,
  checkboxInput("dark_mode", "Dark mode"),
  tags$h2("bslib theming for Virtual Select"),
  virtualSelectInput(
    inputId = "single",
    label = "Single select :",
    choices = month.name,
    search = TRUE
  ),
  virtualSelectInput(
    inputId = "multiple",
    label = "Multiple select:",
    choices = setNames(month.abb, month.name),
    multiple = TRUE
  )
)

server <- function(input, output, session) {
  observe(session$setCurrentTheme(
    if (isTRUE(input$dark_mode)) dark else light
  ))
}

if (interactive())
  shinyApp(ui, server)

.shinyWidgetGalleryFuns$tabswitchInput <- function() {
  tagList(
    tags$h1("switchInput", class = "fw-bold text-primary"),
    tags$h5(
      "via ",
      tags$a(href = "http://www.bootstrap-switch.org/examples.html", "bootstrap-switch.org")
    ),
    br(),

    fluidRow(
      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Default",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = switchInput,
            args = list(inputId = ID(.shinyWidgetGalleryId))
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "TRUE at start",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = switchInput,
            args = list(inputId = ID(.shinyWidgetGalleryId), value = TRUE)
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Change ON/OFF labels",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = switchInput,
            args = list(inputId = ID(.shinyWidgetGalleryId), onLabel = "Yes", offLabel = "No")
          )
        )
      )
      ,
      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Change ON/OFF colors",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = switchInput,
            args = list(inputId = ID(.shinyWidgetGalleryId), onStatus = "success", offStatus = "danger")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Label in the middle",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = switchInput,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "My label", labelWidth = "80px")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Size : mini",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = switchInput,
            args = list(inputId = ID(.shinyWidgetGalleryId), size = "mini")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Size : large",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = switchInput,
            args = list(inputId = ID(.shinyWidgetGalleryId), size = "large")
          )
        )
      )
      ,
      column(
        width = 4,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Icon in the middle",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = switchInput,
            args = list(inputId = ID(.shinyWidgetGalleryId), label = "<i class=\"fa fa-thumbs-up\"></i>")
          )
        )
        ,
        .shinyWidgetGalleryFuns$box_wrapper(
          title = "Update value",
          .shinyWidgetGalleryFuns$widget_wrapper(
            fun = switchInput,
            args = list(inputId = "switchUp", label = "<i class=\"fa fa-thumbs-up\"></i>")
          ),
          br(),
          tags$p("Click to update :"),
          actionGroupButtons(inputIds = c("on", "off"), labels = c("ON", "OFF"))
        )
      )
    )
  )
}

# ------------------------------------------------------------------------ #
#
# Descriptif : Select picker
#     Detail : https://silviomoreto.github.io/bootstrap-select/examples/
#
#
# Auteur : Victor PERRIER
#
# Date creation : 08/09/2016
# Date modification : 08/09/2016
#
# Version 1.0
#
# ------------------------------------------------------------------------ #



library("shiny")
library("shinyWidgets")

function(input, output, session) {

  lapply(
    X = seq_len(20),
    FUN = function(i) {
      output[[paste0("res", i)]] <- renderPrint({
        input[[paste0("id", i)]]
      })
    }
  )

  observeEvent(input$update, {
    updatePickerInput(session = session, inputId = "id16", selected = input$update)
  })

  observeEvent(input$update2, {
    if (input$update2 == "lower") {
      updatePickerInput(session = session, inputId = "id17", choices = c("a", "b", "c", "d"))
    } else {
      updatePickerInput(session = session, inputId = "id17", choices = toupper(c("a", "b", "c", "d")))
    }
  })

}

library("shiny")
library("shinyWidgets")


ui <- fluidPage(
  tags$h1("Update", tags$code("switchInput")),
  br(),
  fluidRow(

    column(
      width = 4,
      panel(
        switchInput(inputId = "switch1"),
        verbatimTextOutput(outputId = "resup1"),
        tags$div(
          class = "btn-group",
          actionButton(inputId = "updatevaluetrue", label = "Set to TRUE"),
          actionButton(inputId = "updatevaluefalse", label = "Set to FALSE")
        ),
        heading = "Update value"
      )
    ),

    column(
      width = 4,
      panel(
        switchInput(inputId = "switch2", label = "My label"),
        verbatimTextOutput(outputId = "resup2"),
        textInput(inputId = "updatelabeltext", label = "Update label:"),
        heading = "Update label"
      )
    ),

    column(
      width = 4,
      panel(
        switchInput(inputId = "switch3", onLabel = "Yeaah", offLabel = "Noooo"),
        verbatimTextOutput(outputId = "resup3"),
        fluidRow(
          column(
            width = 6,
            textInput(inputId = "updateonLabel", label = "Update onLabel:")
          ),
          column(
            width = 6,
            textInput(inputId = "updateoffLabel", label = "Update offLabel:")
          )
        ),
        heading = "Update onLabel & offLabel"
      )
    )
  ),

  fluidRow(

    column(
      width = 4,
      panel(
        switchInput(inputId = "switch4"),
        verbatimTextOutput(outputId = "resup4"),
        fluidRow(
          column(
            width = 6,
            pickerInput(inputId = "updateonStatus", label = "Update onStatus:",
                        choices = c("default", "primary", "success", "info", "warning", "danger"))
          ),
          column(
            width = 6,
            pickerInput(inputId = "updateoffStatus", label = "Update offStatus:",
                        choices = c("default", "primary", "success", "info", "warning", "danger"))
          )
        ),
        heading = "Update onStatus & offStatusr"
      )
    ),

    column(
      width = 4,
      panel(
        switchInput(inputId = "switch5"),
        verbatimTextOutput(outputId = "resup5"),
        checkboxInput(inputId = "disabled", label = "Disabled", value = FALSE),
        heading = "Disabled"
      )
    )

  )

)

server <- function(input, output, session) {

  # Update value
  observeEvent(input$updatevaluetrue, {
    updateSwitchInput(session = session, inputId = "switch1", value = TRUE)
  })
  observeEvent(input$updatevaluefalse, {
    updateSwitchInput(session = session, inputId = "switch1", value = FALSE)
  })
  output$resup1 <- renderPrint({
    input$switch1
  })


  # Update label
  observeEvent(input$updatelabeltext, {
    updateSwitchInput(session = session, inputId = "switch2", label = input$updatelabeltext)
  }, ignoreInit = TRUE)
  output$resup2 <- renderPrint({
    input$switch2
  })


  # Update onLabel & offLabel
  observeEvent(input$updateonLabel, {
    updateSwitchInput(session = session, inputId = "switch3", onLabel = input$updateonLabel)
  }, ignoreInit = TRUE)
  observeEvent(input$updateoffLabel, {
    updateSwitchInput(session = session, inputId = "switch3", offLabel = input$updateoffLabel)
  }, ignoreInit = TRUE)
  output$resup3 <- renderPrint({
    input$switch3
  })


  # Update onStatus & offStatus
  observeEvent(input$updateonStatus, {
    updateSwitchInput(session = session, inputId = "switch4", onStatus = input$updateonStatus)
  }, ignoreInit = TRUE)
  observeEvent(input$updateoffStatus, {
    updateSwitchInput(session = session, inputId = "switch4", offStatus = input$updateoffStatus)
  }, ignoreInit = TRUE)
  output$resup4 <- renderPrint({
    input$switch4
  })


  # Disabled
  observeEvent(input$disabled, {
    updateSwitchInput(session = session, inputId = "switch5", disabled = input$disabled)
  }, ignoreInit = TRUE)
  output$resup5 <- renderPrint({
    input$switch5
  })

}

shinyApp(ui = ui, server = server)
